import{s as Vn,n as Jn,o as Wn}from"../chunks/scheduler.37c15a92.js";import{S as Bn,i as Kn,g as n,s,u as v,A as Qn,h as a,f as e,c as h,j as p,v as f,y as u,k as o,o as i,a as r,w as c,d,t as m,x as g}from"../chunks/index.b01106c0.js";import{I as w}from"../chunks/IconCopyLink.77b762b4.js";function Xn(Ve){let x,Gt,Lt,Vt,$,M,Tt,G,Se,wt,Je="Glossary",Jt,V,We="This is a community-created glossary. Contributions are welcomed!",Wt,y,S,Mt,J,Ne,xt,Be="Agent",Bt,W,Ke="An agent learns to <strong>make decisions by trial and error, with rewards and punishments from the surroundings</strong>.",Kt,b,N,St,B,Ie,$t,Qe="Environment",Qt,K,Xe="An environment is a simulated world <strong>where an agent can learn by interacting with it</strong>.",Xt,_,I,Nt,Q,ze,yt,Ye="Markov Property",Yt,X,Ze="It implies that the action taken by our agent is <strong>conditional solely on the present state and independent of the past states and actions</strong>.",Zt,C,z,It,Y,Re,bt,tn="Observations/State",te,Z,en="<li><strong>State</strong>:  Complete description of the state of the world.</li> <li><strong>Observation</strong>: Partial description of the state of the environment/world.</li>",ee,k,R,zt,tt,Ue,_t,nn="Actions",ne,et,an="<li><strong>Discrete Actions</strong>: Finite number of actions, such as left, right, up, and down.</li> <li><strong>Continuous Actions</strong>: Infinite possibility of actions; for example, in the case of self-driving cars, the driving scenario has an infinite possibility of actions occurring.</li>",ae,E,U,Rt,nt,Oe,Ct,ln="Rewards and Discounting",le,at,rn="<li><strong>Rewards</strong>: Fundamental factor in RL. Tells the agent whether the action taken is good/bad.</li> <li>RL algorithms are focused on maximizing the <strong>cumulative reward</strong>.</li> <li><strong>Reward Hypothesis</strong>: RL problems can be formulated as a maximisation of (cumulative) return.</li> <li><strong>Discounting</strong> is performed because rewards obtained at the start are more likely to happen as they are more predictable than long-term rewards.</li>",re,P,O,Ut,lt,qe,kt,on="Tasks",oe,rt,sn="<li><strong>Episodic</strong>: Has a starting point and an ending point.</li> <li><strong>Continuous</strong>: Has a starting point but no ending point.</li>",ie,A,q,Ot,ot,je,Et,hn="Exploration v/s Exploitation Trade-Off",se,it,pn="<li><strong>Exploration</strong>: It’s all about exploring the environment by trying random actions and receiving feedback/returns/rewards from the environment.</li> <li><strong>Exploitation</strong>: It’s about exploiting what we know about the environment to gain maximum rewards.</li> <li><strong>Exploration-Exploitation Trade-Off</strong>: It balances how much we want to <strong>explore</strong> the environment and how much we want to <strong>exploit</strong> what we know about the environment.</li>",he,H,j,qt,st,De,Pt,un="Policy",pe,ht,vn="<li><strong>Policy</strong>: It is called the agent’s brain. It tells us what action to take, given the state.</li> <li><strong>Optimal Policy</strong>: Policy that <strong>maximizes</strong> the <strong>expected return</strong> when an agent acts according to it. It is learned through <em>training</em>.</li>",ue,L,D,jt,pt,Fe,At,fn="Policy-based Methods:",ve,ut,cn="<li>An approach to solving RL problems.</li> <li>In this method, the Policy is learned directly.</li> <li>Will map each state to the best corresponding action at that state. Or a probability distribution over the set of possible actions at that state.</li>",fe,T,F,Dt,vt,Ge,Ht,dn="Value-based Methods:",ce,ft,mn="<li>Another approach to solving RL problems.</li> <li>Here, instead of training a policy, we train a <strong>value function</strong> that maps each state to the expected value of being in that state.</li>",de,ct,gn="Contributions are welcomed 🤗",me,dt,wn='If you want to improve the course, you can <a href="https://github.com/huggingface/deep-rl-class/pulls" rel="nofollow">open a Pull Request.</a>',ge,mt,xn="This glossary was made possible thanks to:",we,gt,$n='<li><a href="https://github.com/lucifermorningstar1305" rel="nofollow">@lucifermorningstar1305</a></li> <li><a href="https://github.com/daspartho" rel="nofollow">@daspartho</a></li> <li><a href="https://github.com/misza222" rel="nofollow">@misza222</a></li>',xe,Ft,$e;return G=new w({}),J=new w({}),B=new w({}),Q=new w({}),Y=new w({}),tt=new w({}),nt=new w({}),lt=new w({}),ot=new w({}),st=new w({}),pt=new w({}),vt=new w({}),{c(){x=n("meta"),Gt=s(),Lt=n("p"),Vt=s(),$=n("h1"),M=n("a"),Tt=n("span"),v(G.$$.fragment),Se=s(),wt=n("span"),wt.textContent=Je,Jt=s(),V=n("p"),V.textContent=We,Wt=s(),y=n("h3"),S=n("a"),Mt=n("span"),v(J.$$.fragment),Ne=s(),xt=n("span"),xt.textContent=Be,Bt=s(),W=n("p"),W.innerHTML=Ke,Kt=s(),b=n("h3"),N=n("a"),St=n("span"),v(B.$$.fragment),Ie=s(),$t=n("span"),$t.textContent=Qe,Qt=s(),K=n("p"),K.innerHTML=Xe,Xt=s(),_=n("h3"),I=n("a"),Nt=n("span"),v(Q.$$.fragment),ze=s(),yt=n("span"),yt.textContent=Ye,Yt=s(),X=n("p"),X.innerHTML=Ze,Zt=s(),C=n("h3"),z=n("a"),It=n("span"),v(Y.$$.fragment),Re=s(),bt=n("span"),bt.textContent=tn,te=s(),Z=n("ul"),Z.innerHTML=en,ee=s(),k=n("h3"),R=n("a"),zt=n("span"),v(tt.$$.fragment),Ue=s(),_t=n("span"),_t.textContent=nn,ne=s(),et=n("ul"),et.innerHTML=an,ae=s(),E=n("h3"),U=n("a"),Rt=n("span"),v(nt.$$.fragment),Oe=s(),Ct=n("span"),Ct.textContent=ln,le=s(),at=n("ul"),at.innerHTML=rn,re=s(),P=n("h3"),O=n("a"),Ut=n("span"),v(lt.$$.fragment),qe=s(),kt=n("span"),kt.textContent=on,oe=s(),rt=n("ul"),rt.innerHTML=sn,ie=s(),A=n("h3"),q=n("a"),Ot=n("span"),v(ot.$$.fragment),je=s(),Et=n("span"),Et.textContent=hn,se=s(),it=n("ul"),it.innerHTML=pn,he=s(),H=n("h3"),j=n("a"),qt=n("span"),v(st.$$.fragment),De=s(),Pt=n("span"),Pt.textContent=un,pe=s(),ht=n("ul"),ht.innerHTML=vn,ue=s(),L=n("h3"),D=n("a"),jt=n("span"),v(pt.$$.fragment),Fe=s(),At=n("span"),At.textContent=fn,ve=s(),ut=n("ul"),ut.innerHTML=cn,fe=s(),T=n("h3"),F=n("a"),Dt=n("span"),v(vt.$$.fragment),Ge=s(),Ht=n("span"),Ht.textContent=dn,ce=s(),ft=n("ul"),ft.innerHTML=mn,de=s(),ct=n("p"),ct.textContent=gn,me=s(),dt=n("p"),dt.innerHTML=wn,ge=s(),mt=n("p"),mt.textContent=xn,we=s(),gt=n("ul"),gt.innerHTML=$n,xe=s(),Ft=n("p"),this.h()},l(t){const l=Qn("svelte-1phssyn",document.head);x=a(l,"META",{name:!0,content:!0}),l.forEach(e),Gt=h(t),Lt=a(t,"P",{}),p(Lt).forEach(e),Vt=h(t),$=a(t,"H1",{class:!0});var ye=p($);M=a(ye,"A",{id:!0,class:!0,href:!0});var yn=p(M);Tt=a(yn,"SPAN",{});var bn=p(Tt);f(G.$$.fragment,bn),bn.forEach(e),yn.forEach(e),Se=h(ye),wt=a(ye,"SPAN",{"data-svelte-h":!0}),u(wt)!=="svelte-vhnccz"&&(wt.textContent=Je),ye.forEach(e),Jt=h(t),V=a(t,"P",{"data-svelte-h":!0}),u(V)!=="svelte-m5t86f"&&(V.textContent=We),Wt=h(t),y=a(t,"H3",{class:!0});var be=p(y);S=a(be,"A",{id:!0,class:!0,href:!0});var _n=p(S);Mt=a(_n,"SPAN",{});var Cn=p(Mt);f(J.$$.fragment,Cn),Cn.forEach(e),_n.forEach(e),Ne=h(be),xt=a(be,"SPAN",{"data-svelte-h":!0}),u(xt)!=="svelte-kc2r9i"&&(xt.textContent=Be),be.forEach(e),Bt=h(t),W=a(t,"P",{"data-svelte-h":!0}),u(W)!=="svelte-1p6z4un"&&(W.innerHTML=Ke),Kt=h(t),b=a(t,"H3",{class:!0});var _e=p(b);N=a(_e,"A",{id:!0,class:!0,href:!0});var kn=p(N);St=a(kn,"SPAN",{});var En=p(St);f(B.$$.fragment,En),En.forEach(e),kn.forEach(e),Ie=h(_e),$t=a(_e,"SPAN",{"data-svelte-h":!0}),u($t)!=="svelte-qew67i"&&($t.textContent=Qe),_e.forEach(e),Qt=h(t),K=a(t,"P",{"data-svelte-h":!0}),u(K)!=="svelte-zde1p7"&&(K.innerHTML=Xe),Xt=h(t),_=a(t,"H3",{class:!0});var Ce=p(_);I=a(Ce,"A",{id:!0,class:!0,href:!0});var Pn=p(I);Nt=a(Pn,"SPAN",{});var An=p(Nt);f(Q.$$.fragment,An),An.forEach(e),Pn.forEach(e),ze=h(Ce),yt=a(Ce,"SPAN",{"data-svelte-h":!0}),u(yt)!=="svelte-1drgiba"&&(yt.textContent=Ye),Ce.forEach(e),Yt=h(t),X=a(t,"P",{"data-svelte-h":!0}),u(X)!=="svelte-18hhcb"&&(X.innerHTML=Ze),Zt=h(t),C=a(t,"H3",{class:!0});var ke=p(C);z=a(ke,"A",{id:!0,class:!0,href:!0});var Hn=p(z);It=a(Hn,"SPAN",{});var Ln=p(It);f(Y.$$.fragment,Ln),Ln.forEach(e),Hn.forEach(e),Re=h(ke),bt=a(ke,"SPAN",{"data-svelte-h":!0}),u(bt)!=="svelte-1ixwh8u"&&(bt.textContent=tn),ke.forEach(e),te=h(t),Z=a(t,"UL",{"data-svelte-h":!0}),u(Z)!=="svelte-1j13n4z"&&(Z.innerHTML=en),ee=h(t),k=a(t,"H3",{class:!0});var Ee=p(k);R=a(Ee,"A",{id:!0,class:!0,href:!0});var Tn=p(R);zt=a(Tn,"SPAN",{});var Mn=p(zt);f(tt.$$.fragment,Mn),Mn.forEach(e),Tn.forEach(e),Ue=h(Ee),_t=a(Ee,"SPAN",{"data-svelte-h":!0}),u(_t)!=="svelte-xn9i48"&&(_t.textContent=nn),Ee.forEach(e),ne=h(t),et=a(t,"UL",{"data-svelte-h":!0}),u(et)!=="svelte-1sjkr6t"&&(et.innerHTML=an),ae=h(t),E=a(t,"H3",{class:!0});var Pe=p(E);U=a(Pe,"A",{id:!0,class:!0,href:!0});var Sn=p(U);Rt=a(Sn,"SPAN",{});var Nn=p(Rt);f(nt.$$.fragment,Nn),Nn.forEach(e),Sn.forEach(e),Oe=h(Pe),Ct=a(Pe,"SPAN",{"data-svelte-h":!0}),u(Ct)!=="svelte-ln056j"&&(Ct.textContent=ln),Pe.forEach(e),le=h(t),at=a(t,"UL",{"data-svelte-h":!0}),u(at)!=="svelte-ulmuc0"&&(at.innerHTML=rn),re=h(t),P=a(t,"H3",{class:!0});var Ae=p(P);O=a(Ae,"A",{id:!0,class:!0,href:!0});var In=p(O);Ut=a(In,"SPAN",{});var zn=p(Ut);f(lt.$$.fragment,zn),zn.forEach(e),In.forEach(e),qe=h(Ae),kt=a(Ae,"SPAN",{"data-svelte-h":!0}),u(kt)!=="svelte-paqh1p"&&(kt.textContent=on),Ae.forEach(e),oe=h(t),rt=a(t,"UL",{"data-svelte-h":!0}),u(rt)!=="svelte-a8uk51"&&(rt.innerHTML=sn),ie=h(t),A=a(t,"H3",{class:!0});var He=p(A);q=a(He,"A",{id:!0,class:!0,href:!0});var Rn=p(q);Ot=a(Rn,"SPAN",{});var Un=p(Ot);f(ot.$$.fragment,Un),Un.forEach(e),Rn.forEach(e),je=h(He),Et=a(He,"SPAN",{"data-svelte-h":!0}),u(Et)!=="svelte-1kyd9cu"&&(Et.textContent=hn),He.forEach(e),se=h(t),it=a(t,"UL",{"data-svelte-h":!0}),u(it)!=="svelte-1qq2orr"&&(it.innerHTML=pn),he=h(t),H=a(t,"H3",{class:!0});var Le=p(H);j=a(Le,"A",{id:!0,class:!0,href:!0});var On=p(j);qt=a(On,"SPAN",{});var qn=p(qt);f(st.$$.fragment,qn),qn.forEach(e),On.forEach(e),De=h(Le),Pt=a(Le,"SPAN",{"data-svelte-h":!0}),u(Pt)!=="svelte-zgnudr"&&(Pt.textContent=un),Le.forEach(e),pe=h(t),ht=a(t,"UL",{"data-svelte-h":!0}),u(ht)!=="svelte-1cp18vy"&&(ht.innerHTML=vn),ue=h(t),L=a(t,"H3",{class:!0});var Te=p(L);D=a(Te,"A",{id:!0,class:!0,href:!0});var jn=p(D);jt=a(jn,"SPAN",{});var Dn=p(jt);f(pt.$$.fragment,Dn),Dn.forEach(e),jn.forEach(e),Fe=h(Te),At=a(Te,"SPAN",{"data-svelte-h":!0}),u(At)!=="svelte-9qdp1f"&&(At.textContent=fn),Te.forEach(e),ve=h(t),ut=a(t,"UL",{"data-svelte-h":!0}),u(ut)!=="svelte-9o9aul"&&(ut.innerHTML=cn),fe=h(t),T=a(t,"H3",{class:!0});var Me=p(T);F=a(Me,"A",{id:!0,class:!0,href:!0});var Fn=p(F);Dt=a(Fn,"SPAN",{});var Gn=p(Dt);f(vt.$$.fragment,Gn),Gn.forEach(e),Fn.forEach(e),Ge=h(Me),Ht=a(Me,"SPAN",{"data-svelte-h":!0}),u(Ht)!=="svelte-1bzb6im"&&(Ht.textContent=dn),Me.forEach(e),ce=h(t),ft=a(t,"UL",{"data-svelte-h":!0}),u(ft)!=="svelte-1drg0v"&&(ft.innerHTML=mn),de=h(t),ct=a(t,"P",{"data-svelte-h":!0}),u(ct)!=="svelte-uwe8dy"&&(ct.textContent=gn),me=h(t),dt=a(t,"P",{"data-svelte-h":!0}),u(dt)!=="svelte-1p0vyzq"&&(dt.innerHTML=wn),ge=h(t),mt=a(t,"P",{"data-svelte-h":!0}),u(mt)!=="svelte-1abantd"&&(mt.textContent=xn),we=h(t),gt=a(t,"UL",{"data-svelte-h":!0}),u(gt)!=="svelte-1tdpd7w"&&(gt.innerHTML=$n),xe=h(t),Ft=a(t,"P",{}),p(Ft).forEach(e),this.h()},h(){o(x,"name","hf:doc:metadata"),o(x,"content",JSON.stringify(Yn)),o(M,"id","glossary"),o(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(M,"href","#glossary"),o($,"class","relative group"),o(S,"id","agent"),o(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(S,"href","#agent"),o(y,"class","relative group"),o(N,"id","environment"),o(N,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(N,"href","#environment"),o(b,"class","relative group"),o(I,"id","markov-property"),o(I,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(I,"href","#markov-property"),o(_,"class","relative group"),o(z,"id","observationsstate"),o(z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(z,"href","#observationsstate"),o(C,"class","relative group"),o(R,"id","actions"),o(R,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(R,"href","#actions"),o(k,"class","relative group"),o(U,"id","rewards-and-discounting"),o(U,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(U,"href","#rewards-and-discounting"),o(E,"class","relative group"),o(O,"id","tasks"),o(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(O,"href","#tasks"),o(P,"class","relative group"),o(q,"id","exploration-vs-exploitation-tradeoff"),o(q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(q,"href","#exploration-vs-exploitation-tradeoff"),o(A,"class","relative group"),o(j,"id","policy"),o(j,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(j,"href","#policy"),o(H,"class","relative group"),o(D,"id","policybased-methods"),o(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(D,"href","#policybased-methods"),o(L,"class","relative group"),o(F,"id","valuebased-methods"),o(F,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(F,"href","#valuebased-methods"),o(T,"class","relative group")},m(t,l){i(document.head,x),r(t,Gt,l),r(t,Lt,l),r(t,Vt,l),r(t,$,l),i($,M),i(M,Tt),c(G,Tt,null),i($,Se),i($,wt),r(t,Jt,l),r(t,V,l),r(t,Wt,l),r(t,y,l),i(y,S),i(S,Mt),c(J,Mt,null),i(y,Ne),i(y,xt),r(t,Bt,l),r(t,W,l),r(t,Kt,l),r(t,b,l),i(b,N),i(N,St),c(B,St,null),i(b,Ie),i(b,$t),r(t,Qt,l),r(t,K,l),r(t,Xt,l),r(t,_,l),i(_,I),i(I,Nt),c(Q,Nt,null),i(_,ze),i(_,yt),r(t,Yt,l),r(t,X,l),r(t,Zt,l),r(t,C,l),i(C,z),i(z,It),c(Y,It,null),i(C,Re),i(C,bt),r(t,te,l),r(t,Z,l),r(t,ee,l),r(t,k,l),i(k,R),i(R,zt),c(tt,zt,null),i(k,Ue),i(k,_t),r(t,ne,l),r(t,et,l),r(t,ae,l),r(t,E,l),i(E,U),i(U,Rt),c(nt,Rt,null),i(E,Oe),i(E,Ct),r(t,le,l),r(t,at,l),r(t,re,l),r(t,P,l),i(P,O),i(O,Ut),c(lt,Ut,null),i(P,qe),i(P,kt),r(t,oe,l),r(t,rt,l),r(t,ie,l),r(t,A,l),i(A,q),i(q,Ot),c(ot,Ot,null),i(A,je),i(A,Et),r(t,se,l),r(t,it,l),r(t,he,l),r(t,H,l),i(H,j),i(j,qt),c(st,qt,null),i(H,De),i(H,Pt),r(t,pe,l),r(t,ht,l),r(t,ue,l),r(t,L,l),i(L,D),i(D,jt),c(pt,jt,null),i(L,Fe),i(L,At),r(t,ve,l),r(t,ut,l),r(t,fe,l),r(t,T,l),i(T,F),i(F,Dt),c(vt,Dt,null),i(T,Ge),i(T,Ht),r(t,ce,l),r(t,ft,l),r(t,de,l),r(t,ct,l),r(t,me,l),r(t,dt,l),r(t,ge,l),r(t,mt,l),r(t,we,l),r(t,gt,l),r(t,xe,l),r(t,Ft,l),$e=!0},p:Jn,i(t){$e||(d(G.$$.fragment,t),d(J.$$.fragment,t),d(B.$$.fragment,t),d(Q.$$.fragment,t),d(Y.$$.fragment,t),d(tt.$$.fragment,t),d(nt.$$.fragment,t),d(lt.$$.fragment,t),d(ot.$$.fragment,t),d(st.$$.fragment,t),d(pt.$$.fragment,t),d(vt.$$.fragment,t),$e=!0)},o(t){m(G.$$.fragment,t),m(J.$$.fragment,t),m(B.$$.fragment,t),m(Q.$$.fragment,t),m(Y.$$.fragment,t),m(tt.$$.fragment,t),m(nt.$$.fragment,t),m(lt.$$.fragment,t),m(ot.$$.fragment,t),m(st.$$.fragment,t),m(pt.$$.fragment,t),m(vt.$$.fragment,t),$e=!1},d(t){t&&(e(Gt),e(Lt),e(Vt),e($),e(Jt),e(V),e(Wt),e(y),e(Bt),e(W),e(Kt),e(b),e(Qt),e(K),e(Xt),e(_),e(Yt),e(X),e(Zt),e(C),e(te),e(Z),e(ee),e(k),e(ne),e(et),e(ae),e(E),e(le),e(at),e(re),e(P),e(oe),e(rt),e(ie),e(A),e(se),e(it),e(he),e(H),e(pe),e(ht),e(ue),e(L),e(ve),e(ut),e(fe),e(T),e(ce),e(ft),e(de),e(ct),e(me),e(dt),e(ge),e(mt),e(we),e(gt),e(xe),e(Ft)),e(x),g(G),g(J),g(B),g(Q),g(Y),g(tt),g(nt),g(lt),g(ot),g(st),g(pt),g(vt)}}}const Yn={local:"glossary",sections:[{local:"agent",title:"Agent"},{local:"environment",title:"Environment"},{local:"markov-property",title:"Markov Property"},{local:"observationsstate",title:"Observations/State"},{local:"actions",title:"Actions"},{local:"rewards-and-discounting",title:"Rewards and Discounting"},{local:"tasks",title:"Tasks"},{local:"exploration-vs-exploitation-tradeoff",title:"Exploration v/s Exploitation Trade-Off"},{local:"policy",title:"Policy"},{local:"policybased-methods",title:"Policy-based Methods:"},{local:"valuebased-methods",title:"Value-based Methods:"}],title:"Glossary "};function Zn(Ve){return Wn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class aa extends Bn{constructor(x){super(),Kn(this,x,Zn,Xn,Vn,{})}}export{aa as component};
