import{s as rt,f as ot,n as st,o as ut}from"../chunks/scheduler.37c15a92.js";import{S as mt,i as pt,g as a,s as o,u as ft,A as ct,h as l,f as e,c as r,j as P,v as gt,y as p,k as s,o as k,a as i,w as ht,d as dt,t as vt,x as Lt}from"../chunks/index.b01106c0.js";import{I as _t}from"../chunks/IconCopyLink.77b762b4.js";function wt(W){let u,R,M,$,m,f,H,g,O,b,B="Introduction to Q-Learning",S,c,J,A,h,K="In the first unit of this class, we learned about Reinforcement Learning (RL), the RL process, and the different methods to solve an RL problem. We also <strong>trained our first agents and uploaded them to the Hugging Face Hub.</strong>",E,d,V="In this unit, we’re going to <strong>dive deeper into one of the Reinforcement Learning methods: value-based methods</strong> and study our first RL algorithm: <strong>Q-Learning.</strong>",I,v,X="We’ll also <strong>implement our first RL agent from scratch</strong>, a Q-Learning agent, and will train it in two environments:",q,L,Y="<li>Frozen-Lake-v1 (non-slippery version): where our agent will need to <strong>go from the starting state (S) to the goal state (G)</strong> by walking only on frozen tiles (F) and avoiding holes (H).</li> <li>An autonomous taxi: where our agent will need <strong>to learn to navigate</strong> a city to <strong>transport its passengers from point A to point B.</strong></li>",Q,_,Z,z,w,tt="Concretely, we will:",j,x,et="<li>Learn about <strong>value-based methods</strong>.</li> <li>Learn about the <strong>differences between Monte Carlo and Temporal Difference Learning</strong>.</li> <li>Study and implement <strong>our first RL algorithm</strong>: Q-Learning.</li>",D,y,nt="This unit is <strong>fundamental if you want to be able to work on Deep Q-Learning</strong>: the first Deep RL algorithm that played Atari games and beat the human level on some of them (breakout, space invaders, etc).",F,C,it="So let’s get started! 🚀",G,T,N;return g=new _t({}),{c(){u=a("meta"),R=o(),M=a("p"),$=o(),m=a("h1"),f=a("a"),H=a("span"),ft(g.$$.fragment),O=o(),b=a("span"),b.textContent=B,S=o(),c=a("img"),A=o(),h=a("p"),h.innerHTML=K,E=o(),d=a("p"),d.innerHTML=V,I=o(),v=a("p"),v.innerHTML=X,q=o(),L=a("ol"),L.innerHTML=Y,Q=o(),_=a("img"),z=o(),w=a("p"),w.textContent=tt,j=o(),x=a("ul"),x.innerHTML=et,D=o(),y=a("p"),y.innerHTML=nt,F=o(),C=a("p"),C.textContent=it,G=o(),T=a("p"),this.h()},l(t){const n=ct("svelte-1phssyn",document.head);u=l(n,"META",{name:!0,content:!0}),n.forEach(e),R=r(t),M=l(t,"P",{}),P(M).forEach(e),$=r(t),m=l(t,"H1",{class:!0});var U=P(m);f=l(U,"A",{id:!0,class:!0,href:!0});var at=P(f);H=l(at,"SPAN",{});var lt=P(H);gt(g.$$.fragment,lt),lt.forEach(e),at.forEach(e),O=r(U),b=l(U,"SPAN",{"data-svelte-h":!0}),p(b)!=="svelte-1ezd0oa"&&(b.textContent=B),U.forEach(e),S=r(t),c=l(t,"IMG",{src:!0,alt:!0,width:!0}),A=r(t),h=l(t,"P",{"data-svelte-h":!0}),p(h)!=="svelte-1ynp68f"&&(h.innerHTML=K),E=r(t),d=l(t,"P",{"data-svelte-h":!0}),p(d)!=="svelte-1dfcpck"&&(d.innerHTML=V),I=r(t),v=l(t,"P",{"data-svelte-h":!0}),p(v)!=="svelte-1xt90qk"&&(v.innerHTML=X),q=r(t),L=l(t,"OL",{"data-svelte-h":!0}),p(L)!=="svelte-1avcekp"&&(L.innerHTML=Y),Q=r(t),_=l(t,"IMG",{src:!0,alt:!0}),z=r(t),w=l(t,"P",{"data-svelte-h":!0}),p(w)!=="svelte-innzr2"&&(w.textContent=tt),j=r(t),x=l(t,"UL",{"data-svelte-h":!0}),p(x)!=="svelte-y97j7m"&&(x.innerHTML=et),D=r(t),y=l(t,"P",{"data-svelte-h":!0}),p(y)!=="svelte-1c70rr4"&&(y.innerHTML=nt),F=r(t),C=l(t,"P",{"data-svelte-h":!0}),p(C)!=="svelte-vkoquy"&&(C.textContent=it),G=r(t),T=l(t,"P",{}),P(T).forEach(e),this.h()},h(){s(u,"name","hf:doc:metadata"),s(u,"content",JSON.stringify(xt)),s(f,"id","introduction-q-learning"),s(f,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(f,"href","#introduction-q-learning"),s(m,"class","relative group"),ot(c.src,J="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/thumbnail.jpg")||s(c,"src",J),s(c,"alt","Unit 2 thumbnail"),s(c,"width","100%"),ot(_.src,Z="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/envs.gif")||s(_,"src",Z),s(_,"alt","Environments")},m(t,n){k(document.head,u),i(t,R,n),i(t,M,n),i(t,$,n),i(t,m,n),k(m,f),k(f,H),ht(g,H,null),k(m,O),k(m,b),i(t,S,n),i(t,c,n),i(t,A,n),i(t,h,n),i(t,E,n),i(t,d,n),i(t,I,n),i(t,v,n),i(t,q,n),i(t,L,n),i(t,Q,n),i(t,_,n),i(t,z,n),i(t,w,n),i(t,j,n),i(t,x,n),i(t,D,n),i(t,y,n),i(t,F,n),i(t,C,n),i(t,G,n),i(t,T,n),N=!0},p:st,i(t){N||(dt(g.$$.fragment,t),N=!0)},o(t){vt(g.$$.fragment,t),N=!1},d(t){t&&(e(R),e(M),e($),e(m),e(S),e(c),e(A),e(h),e(E),e(d),e(I),e(v),e(q),e(L),e(Q),e(_),e(z),e(w),e(j),e(x),e(D),e(y),e(F),e(C),e(G),e(T)),e(u),Lt(g)}}}const xt={local:"introduction-q-learning",title:"Introduction to Q-Learning "};function yt(W){return ut(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ht extends mt{constructor(u){super(),pt(this,u,yt,wt,rt,{})}}export{Ht as component};
