import{s as zp,f as w,n as kp,o as Lp}from"../chunks/scheduler.37c15a92.js";import{S as Sp,i as Tp,g as l,s as m,u as Re,m as c,H as u,A as Cp,h as p,f as a,c as i,j as r,v as Pe,y as g,n as h,B as v,k as o,o as t,a as e,w as He,d as Ie,t as De,x as Ne}from"../chunks/index.b01106c0.js";import{I as $e}from"../chunks/IconCopyLink.77b762b4.js";function Gp(je){let _,Ma,ga,za,M,R,ua,j,Cn,Ts,Oe="Monte Carlo vs Temporal Difference Learning",ka,O,Ae="The last thing we need to discuss before diving into Q-Learning is the two learning strategies.",La,A,We="Remember that an RL agent <strong>learns by interacting with its environment.</strong> The idea is that <strong>given the experience and the received reward, the agent will update its value function or policy.</strong>",Sa,W,qe="Monte Carlo and Temporal Difference Learning are two different <strong>strategies on how to train our value function or our policy function.</strong> Both of them <strong>use experience to solve the RL problem.</strong>",Ta,z,Gn,Cs,Ue="an entire episode of experience before learning.",En,q,Vn,Ca,Jl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>A</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo separator="true">,</mo><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">S_t, A_t, R_{t+1}, S_{t+1}</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Ga,Ea,U,Be="We’ll explain both of them <strong>using a value-based method example.</strong>",Va,k,P,va,B,Rn,Gs,Fe="Monte Carlo: learning at the end of the episode",Ra,L,Pn,Pa,Ql='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Ha,F,Hn,Ia,Kl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_t)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Da,Na,J,Je="So it requires a <strong>complete episode of interaction before updating our value function.</strong>",$a,Q,Qe,ja,K,Ke="If we take an example:",Oa,X,Xe,Aa,d,Es,Ye="<p>We always start the episode <strong>at the same starting point.</strong></p>",In,Vs,Ze="<p><strong>The agent takes actions using the policy</strong>. For instance, using an Epsilon Greedy Strategy, a policy that alternates between exploration (random actions) and exploitation.</p>",Dn,Rs,sl="<p>We get <strong>the reward and the next state.</strong></p>",Nn,Ps,al="<p>We terminate the episode if the cat eats the mouse or if the mouse moves &gt; 10 steps.</p>",$n,Hs,tl=`<p>At the end of the episode, <strong>we have a list of State, Actions, Rewards, and Next States tuples</strong>
For instance [[State tile 3 bottom, Go Left, +1, State tile 2 bottom], [State tile 2 bottom, Go Left, +0, State tile 1 bottom]…]</p>`,jn,da,Is,Ds,On,Wa,Xl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',An,Wn,Y,Ns,qn,Z,Un,qa,Yl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>s</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(s_t)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Ua,Bn,$s,nl,Fn,js,el="<p>Then <strong>start a new game with this new knowledge</strong></p>",Ba,ss,ll="By running more and more episodes, <strong>the agent will learn to play better and better.</strong>",Fa,as,pl,Ja,ts,ml="For instance, if we train a state-value function using Monte Carlo:",Qa,ns,il='<li><p>We initialize our value function <strong>so that it returns 0 value for each state</strong></p></li> <li><p>Our learning rate (lr) is 0.1 and our discount rate is 1 (= no discount)</p></li> <li><p>Our mouse <strong>explores the environment and takes random actions</strong></p> <img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-4.jpg" alt="Monte Carlo"/></li>',Ka,es,rl='<li><p>The mouse made more than 10 steps, so the episode ends .</p> <img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-4p.jpg" alt="Monte Carlo"/></li>',Xa,Os,As,Jn,Ws,Qn,Ya,Zl='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>G</mi><mrow><mi>t</mi><mo>=</mo><mn>0</mn></mrow></mrow><annotation encoding="application/x-tex">G{t=0}</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6833em;"></span><span class="mord mathnormal">G</span><span class="mord"><span class="mord mathnormal">t</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mord">0</span></span></span></span></span>',Za,ls,st,sp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub><mo>=</mo><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo>+</mo><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>2</mn></mrow></msub><mo>+</mo><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>3</mn></mrow></msub><mi mathvariant="normal">.</mi><mi mathvariant="normal">.</mi><mi mathvariant="normal">.</mi></mrow><annotation encoding="application/x-tex">G_t = R_{t+1} + R_{t+2} + R_{t+3} ...</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">2</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">3</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mord">...</span></span></span></span>',at,tt,qs,nt,ap='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mn>0</mn></msub><mo>=</mo><msub><mi>R</mi><mn>1</mn></msub><mo>+</mo><msub><mi>R</mi><mn>2</mn></msub><mo>+</mo><msub><mi>R</mi><mn>3</mn></msub><mo>…</mo></mrow><annotation encoding="application/x-tex">G_0 = R_{1} + R_{2} + R_{3}…</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">2</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">3</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.1667em;"></span><span class="minner">…</span></span></span></span>',et,Us,lt,tp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mn>0</mn></msub><mo>=</mo><mn>1</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>1</mn><mo>+</mo><mn>1</mn><mo>+</mo><mn>0</mn><mo>+</mo><mn>0</mn></mrow><annotation encoding="application/x-tex">G_0 = 1 + 0 + 0 + 0 + 0 + 0 + 1 + 1 + 0 + 0</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0</span></span></span></span>',pt,Bs,mt,np='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mn>0</mn></msub><mo>=</mo><mn>3</mn></mrow><annotation encoding="application/x-tex">G_0 = 3</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">3</span></span></span></span>',it,Fs,ps,S,Kn,Js,cl="new",Xn,rt,ep='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_0)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',ct,Yn,Qs,hl,ht,Ks,ot,lp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>+</mo><mi>l</mi><mi>r</mi><mo>∗</mo><mo stretchy="false">[</mo><msub><mi>G</mi><mn>0</mn></msub><mtext>—</mtext><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex">V(S_0) = V(S_0) + lr * [G_0 — V(S_0)]</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.01968em;">l</span><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord">—</span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)]</span></span></span></span>',gt,Xs,ut,pp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mn>0</mn><mo>+</mo><mn>0.1</mn><mo>∗</mo><mo stretchy="false">[</mo><mn>3</mn><mtext>–</mtext><mn>0</mn><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex">V(S_0) = 0 + 0.1 * [3 – 0]</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0.1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">3–0</span><span class="mclose">]</span></span></span></span>',vt,Ys,dt,mp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mn>0.3</mn></mrow><annotation encoding="application/x-tex">V(S_0) = 0.3</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0.3</span></span></span></span>',yt,ms,ol,ft,T,H,ya,is,Zn,Zs,gl="Temporal Difference Learning: learning at each step",wt,f,sa,se,xt,ip='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">S_{t+1}</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',ae,bt,rp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_t)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',_t,Mt,cp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">R_{t+1}</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',zt,kt,hp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>γ</mi><mo>∗</mo><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\gamma * V(S_{t+1})</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6597em;vertical-align:-0.1944em;"></span><span class="mord mathnormal" style="margin-right:0.05556em;">γ</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Lt,St,rs,te,cs,ne,Tt,op='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_t)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Ct,Gt,C,ee,Et,gp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Vt,G,le,Rt,up='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Pt,Ht,vp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex">R_{t+1}</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',It,Dt,hs,pe,E,me,Nt,dp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_{t+1})</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',$t,jt,yp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Ot,At,os,ul,Wt,gs,vl="This method is called TD(0) or <strong>one-step TD (update the value function after any individual step).</strong>",qt,us,dl,Ut,vs,yl="If we take the same example,",Bt,ds,fl,Ft,x,aa,wl="<p>We initialize our value function so that it returns 0 value for each state.</p>",ie,ta,xl="<p>Our learning rate (lr) is 0.1, and our discount rate is 1 (no discount).</p>",re,na,bl="<p>Our mouse begins to explore the environment and takes a random action: <strong>going to the left</strong></p>",ce,ys,I,he,Jt,fp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo>=</mo><mn>1</mn></mrow><annotation encoding="application/x-tex">R_{t+1} = 1</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">1</span></span></span></span>',Qt,ea,_l="it eats a piece of cheese",oe,la,Ml,Kt,fs,zl,Xt,D,ge,Yt,wp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">V(S_0)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',Zt,sn,ws,ue,an,xp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>+</mo><mi>l</mi><mi>r</mi><mo>∗</mo><mo stretchy="false">[</mo><msub><mi>R</mi><mn>1</mn></msub><mo>+</mo><mi>γ</mi><mo>∗</mo><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>1</mn></msub><mo stretchy="false">)</mo><mo>−</mo><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex">V(S_0) = V(S_0) + lr * [R_1 + \\gamma * V(S_1) - V(S_0)]</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.01968em;">l</span><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">1</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6597em;vertical-align:-0.1944em;"></span><span class="mord mathnormal" style="margin-right:0.05556em;">γ</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">1</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)]</span></span></span></span>',tn,xs,ve,nn,bp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mn>0</mn><mo>+</mo><mn>0.1</mn><mo>∗</mo><mo stretchy="false">[</mo><mn>1</mn><mo>+</mo><mn>1</mn><mo>∗</mo><mn>0</mn><mtext>–</mtext><mn>0</mn><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex">V(S_0) = 0 + 0.1 * [1 + 1 * 0–0]</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">0</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0.1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord">0–0</span><span class="mclose">]</span></span></span></span>',en,bs,de,ln,_p='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mn>0</mn></msub><mo stretchy="false">)</mo><mo>=</mo><mn>0.1</mn></mrow><annotation encoding="application/x-tex">V(S_0) = 0.1</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0.1</span></span></span></span>',pn,_s,kl="So we just updated our value function for State 0.",mn,Ms,Ll="Now we <strong>continue to interact with this environment with our updated value function.</strong>",rn,zs,Sl,cn,ks,Tl="To summarize:",hn,N,pa,Cl="<p>With <em>Monte Carlo</em>, we update the value function from a complete episode, and so we <strong>use the actual accurate discounted return of this episode.</strong></p>",ye,Ls,b,fe,ma,Gl="TD Learning",we,on,Mp='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>G</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex">G_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">G</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',gn,ia,El="an estimated return called the TD target.",xe,ra,Vl,un,fa,vn;return j=new $e({}),B=new $e({}),is=new $e({}),{c(){_=l("meta"),Ma=m(),ga=l("p"),za=m(),M=l("h1"),R=l("a"),ua=l("span"),Re(j.$$.fragment),Cn=m(),Ts=l("span"),Ts.textContent=Oe,ka=m(),O=l("p"),O.textContent=Ae,La=m(),A=l("p"),A.innerHTML=We,Sa=m(),W=l("p"),W.innerHTML=qe,Ta=m(),z=l("p"),Gn=c("On one hand, Monte Carlo uses "),Cs=l("strong"),Cs.textContent=Ue,En=c(" On the other hand, Temporal Difference uses "),q=l("strong"),Vn=c("only a step ( "),Ca=new u(!1),Ga=c(" ) to learn."),Ea=m(),U=l("p"),U.innerHTML=Be,Va=m(),k=l("h2"),P=l("a"),va=l("span"),Re(B.$$.fragment),Rn=m(),Gs=l("span"),Gs.textContent=Fe,Ra=m(),L=l("p"),Pn=c("Monte Carlo waits until the end of the episode, calculates  "),Pa=new u(!1),Ha=c(" (return) and uses it as "),F=l("strong"),Hn=c("a target for updating  "),Ia=new u(!1),Da=c("."),Na=m(),J=l("p"),J.innerHTML=Je,$a=m(),Q=l("img"),ja=m(),K=l("p"),K.textContent=Ke,Oa=m(),X=l("img"),Aa=m(),d=l("ul"),Es=l("li"),Es.innerHTML=Ye,In=m(),Vs=l("li"),Vs.innerHTML=Ze,Dn=m(),Rs=l("li"),Rs.innerHTML=sl,Nn=m(),Ps=l("li"),Ps.innerHTML=al,$n=m(),Hs=l("li"),Hs.innerHTML=tl,jn=m(),da=l("li"),Is=l("p"),Ds=l("strong"),On=c("The agent will sum the total rewards "),Wa=new u(!1),An=c(" (to see how well it did)."),Wn=m(),Y=l("li"),Ns=l("p"),qn=c("It will then "),Z=l("strong"),Un=c("update "),qa=new u(!1),Ua=c(" based on the formula"),Bn=m(),$s=l("img"),Fn=m(),js=l("li"),js.innerHTML=el,Ba=m(),ss=l("p"),ss.innerHTML=ll,Fa=m(),as=l("img"),Ja=m(),ts=l("p"),ts.textContent=ml,Qa=m(),ns=l("ul"),ns.innerHTML=il,Ka=m(),es=l("ul"),es.innerHTML=rl,Xa=m(),Os=l("ul"),As=l("li"),Jn=c("We have a list of state, action, rewards, next_state, "),Ws=l("strong"),Qn=c("we need to calculate the return "),Ya=new u(!1),Za=m(),ls=l("p"),st=new u(!1),at=c(" (for simplicity, we don’t discount the rewards)"),tt=m(),qs=l("p"),nt=new u(!1),et=m(),Us=l("p"),lt=new u(!1),pt=m(),Bs=l("p"),mt=new u(!1),it=m(),Fs=l("ul"),ps=l("li"),S=l("p"),Kn=c("We can now compute the "),Js=l("strong"),Js.textContent=cl,Xn=m(),rt=new u(!1),ct=c(":"),Yn=m(),Qs=l("img"),ht=m(),Ks=l("p"),ot=new u(!1),gt=m(),Xs=l("p"),ut=new u(!1),vt=m(),Ys=l("p"),dt=new u(!1),yt=m(),ms=l("img"),ft=m(),T=l("h2"),H=l("a"),ya=l("span"),Re(is.$$.fragment),Zn=m(),Zs=l("span"),Zs.textContent=gl,wt=m(),f=l("p"),sa=l("strong"),se=c("Temporal Difference, on the other hand, waits for only one interaction (one step) "),xt=new u(!1),ae=c(" to form a TD target and update "),bt=new u(!1),_t=c(" using "),Mt=new u(!1),zt=c(" and "),kt=new u(!1),Lt=c("."),St=m(),rs=l("p"),te=c("The idea with "),cs=l("strong"),ne=c("TD is to update the "),Tt=new u(!1),Ct=c(" at each step."),Gt=m(),C=l("p"),ee=c("But because we didn’t experience an entire episode, we don’t have "),Et=new u(!1),Vt=c(" (expected return). Instead, "),G=l("strong"),le=c("we estimate "),Rt=new u(!1),Pt=c(" by adding "),Ht=new u(!1),It=c(" and the discounted value of the next state."),Dt=m(),hs=l("p"),pe=c("This is called bootstrapping. It’s called this "),E=l("strong"),me=c("because TD bases its update in part on an existing estimate "),Nt=new u(!1),$t=c(" and not a complete sample "),jt=new u(!1),Ot=c("."),At=m(),os=l("img"),Wt=m(),gs=l("p"),gs.innerHTML=vl,qt=m(),us=l("img"),Ut=m(),vs=l("p"),vs.textContent=yl,Bt=m(),ds=l("img"),Ft=m(),x=l("ul"),aa=l("li"),aa.innerHTML=wl,ie=m(),ta=l("li"),ta.innerHTML=xl,re=m(),na=l("li"),na.innerHTML=bl,ce=m(),ys=l("li"),I=l("p"),he=c("It gets a reward  "),Jt=new u(!1),Qt=c(" since "),ea=l("strong"),ea.textContent=_l,oe=m(),la=l("img"),Kt=m(),fs=l("img"),Xt=m(),D=l("p"),ge=c("We can now update  "),Yt=new u(!1),Zt=c(":"),sn=m(),ws=l("p"),ue=c("New  "),an=new u(!1),tn=m(),xs=l("p"),ve=c("New "),nn=new u(!1),en=m(),bs=l("p"),de=c("New "),ln=new u(!1),pn=m(),_s=l("p"),_s.textContent=kl,mn=m(),Ms=l("p"),Ms.innerHTML=Ll,rn=m(),zs=l("img"),cn=m(),ks=l("p"),ks.textContent=Tl,hn=m(),N=l("ul"),pa=l("li"),pa.innerHTML=Cl,ye=m(),Ls=l("li"),b=l("p"),fe=c("With "),ma=l("em"),ma.textContent=Gl,we=c(", we update the value function from a step, and we replace "),on=new u(!1),gn=c(", which we don’t know, with "),ia=l("strong"),ia.textContent=El,xe=m(),ra=l("img"),un=m(),fa=l("p"),this.h()},l(s){const n=Cp("svelte-1phssyn",document.head);_=p(n,"META",{name:!0,content:!0}),n.forEach(a),Ma=i(s),ga=p(s,"P",{}),r(ga).forEach(a),za=i(s),M=p(s,"H1",{class:!0});var dn=r(M);R=p(dn,"A",{id:!0,class:!0,href:!0});var Rl=r(R);ua=p(Rl,"SPAN",{});var Pl=r(ua);Pe(j.$$.fragment,Pl),Pl.forEach(a),Rl.forEach(a),Cn=i(dn),Ts=p(dn,"SPAN",{"data-svelte-h":!0}),g(Ts)!=="svelte-zn2fdf"&&(Ts.textContent=Oe),dn.forEach(a),ka=i(s),O=p(s,"P",{"data-svelte-h":!0}),g(O)!=="svelte-1akl2qa"&&(O.textContent=Ae),La=i(s),A=p(s,"P",{"data-svelte-h":!0}),g(A)!=="svelte-66f1fn"&&(A.innerHTML=We),Sa=i(s),W=p(s,"P",{"data-svelte-h":!0}),g(W)!=="svelte-c9mnn7"&&(W.innerHTML=qe),Ta=i(s),z=p(s,"P",{});var wa=r(z);Gn=h(wa,"On one hand, Monte Carlo uses "),Cs=p(wa,"STRONG",{"data-svelte-h":!0}),g(Cs)!=="svelte-qfkr11"&&(Cs.textContent=Ue),En=h(wa," On the other hand, Temporal Difference uses "),q=p(wa,"STRONG",{});var yn=r(q);Vn=h(yn,"only a step ( "),Ca=v(yn,!1),Ga=h(yn," ) to learn."),yn.forEach(a),wa.forEach(a),Ea=i(s),U=p(s,"P",{"data-svelte-h":!0}),g(U)!=="svelte-15q9y0k"&&(U.innerHTML=Be),Va=i(s),k=p(s,"H2",{class:!0});var fn=r(k);P=p(fn,"A",{id:!0,class:!0,href:!0});var Hl=r(P);va=p(Hl,"SPAN",{});var Il=r(va);Pe(B.$$.fragment,Il),Il.forEach(a),Hl.forEach(a),Rn=i(fn),Gs=p(fn,"SPAN",{"data-svelte-h":!0}),g(Gs)!=="svelte-174si69"&&(Gs.textContent=Fe),fn.forEach(a),Ra=i(s),L=p(s,"P",{});var xa=r(L);Pn=h(xa,"Monte Carlo waits until the end of the episode, calculates  "),Pa=v(xa,!1),Ha=h(xa," (return) and uses it as "),F=p(xa,"STRONG",{});var wn=r(F);Hn=h(wn,"a target for updating  "),Ia=v(wn,!1),Da=h(wn,"."),wn.forEach(a),xa.forEach(a),Na=i(s),J=p(s,"P",{"data-svelte-h":!0}),g(J)!=="svelte-1qajh7u"&&(J.innerHTML=Je),$a=i(s),Q=p(s,"IMG",{src:!0,alt:!0}),ja=i(s),K=p(s,"P",{"data-svelte-h":!0}),g(K)!=="svelte-w96c5b"&&(K.textContent=Ke),Oa=i(s),X=p(s,"IMG",{src:!0,alt:!0}),Aa=i(s),d=p(s,"UL",{});var y=r(d);Es=p(y,"LI",{"data-svelte-h":!0}),g(Es)!=="svelte-em32nl"&&(Es.innerHTML=Ye),In=i(y),Vs=p(y,"LI",{"data-svelte-h":!0}),g(Vs)!=="svelte-1xtd55m"&&(Vs.innerHTML=Ze),Dn=i(y),Rs=p(y,"LI",{"data-svelte-h":!0}),g(Rs)!=="svelte-ragojc"&&(Rs.innerHTML=sl),Nn=i(y),Ps=p(y,"LI",{"data-svelte-h":!0}),g(Ps)!=="svelte-bq5445"&&(Ps.innerHTML=al),$n=i(y),Hs=p(y,"LI",{"data-svelte-h":!0}),g(Hs)!=="svelte-10uvow2"&&(Hs.innerHTML=tl),jn=i(y),da=p(y,"LI",{});var Dl=r(da);Is=p(Dl,"P",{});var be=r(Is);Ds=p(be,"STRONG",{});var _e=r(Ds);On=h(_e,"The agent will sum the total rewards "),Wa=v(_e,!1),_e.forEach(a),An=h(be," (to see how well it did)."),be.forEach(a),Dl.forEach(a),Wn=i(y),Y=p(y,"LI",{});var xn=r(Y);Ns=p(xn,"P",{});var Me=r(Ns);qn=h(Me,"It will then "),Z=p(Me,"STRONG",{});var bn=r(Z);Un=h(bn,"update "),qa=v(bn,!1),Ua=h(bn," based on the formula"),bn.forEach(a),Me.forEach(a),Bn=i(xn),$s=p(xn,"IMG",{src:!0,alt:!0}),xn.forEach(a),Fn=i(y),js=p(y,"LI",{"data-svelte-h":!0}),g(js)!=="svelte-1a0nyac"&&(js.innerHTML=el),y.forEach(a),Ba=i(s),ss=p(s,"P",{"data-svelte-h":!0}),g(ss)!=="svelte-12n0xeg"&&(ss.innerHTML=ll),Fa=i(s),as=p(s,"IMG",{src:!0,alt:!0}),Ja=i(s),ts=p(s,"P",{"data-svelte-h":!0}),g(ts)!=="svelte-1xxhd0z"&&(ts.textContent=ml),Qa=i(s),ns=p(s,"UL",{"data-svelte-h":!0}),g(ns)!=="svelte-fine1n"&&(ns.innerHTML=il),Ka=i(s),es=p(s,"UL",{"data-svelte-h":!0}),g(es)!=="svelte-h65p8t"&&(es.innerHTML=rl),Xa=i(s),Os=p(s,"UL",{});var Nl=r(Os);As=p(Nl,"LI",{});var ze=r(As);Jn=h(ze,"We have a list of state, action, rewards, next_state, "),Ws=p(ze,"STRONG",{});var ke=r(Ws);Qn=h(ke,"we need to calculate the return "),Ya=v(ke,!1),ke.forEach(a),ze.forEach(a),Nl.forEach(a),Za=i(s),ls=p(s,"P",{});var Le=r(ls);st=v(Le,!1),at=h(Le," (for simplicity, we don’t discount the rewards)"),Le.forEach(a),tt=i(s),qs=p(s,"P",{});var $l=r(qs);nt=v($l,!1),$l.forEach(a),et=i(s),Us=p(s,"P",{});var jl=r(Us);lt=v(jl,!1),jl.forEach(a),pt=i(s),Bs=p(s,"P",{});var Ol=r(Bs);mt=v(Ol,!1),Ol.forEach(a),it=i(s),Fs=p(s,"UL",{});var Al=r(Fs);ps=p(Al,"LI",{});var _n=r(ps);S=p(_n,"P",{});var ca=r(S);Kn=h(ca,"We can now compute the "),Js=p(ca,"STRONG",{"data-svelte-h":!0}),g(Js)!=="svelte-xvdw54"&&(Js.textContent=cl),Xn=i(ca),rt=v(ca,!1),ct=h(ca,":"),ca.forEach(a),Yn=i(_n),Qs=p(_n,"IMG",{src:!0,alt:!0}),_n.forEach(a),Al.forEach(a),ht=i(s),Ks=p(s,"P",{});var Wl=r(Ks);ot=v(Wl,!1),Wl.forEach(a),gt=i(s),Xs=p(s,"P",{});var ql=r(Xs);ut=v(ql,!1),ql.forEach(a),vt=i(s),Ys=p(s,"P",{});var Ul=r(Ys);dt=v(Ul,!1),Ul.forEach(a),yt=i(s),ms=p(s,"IMG",{src:!0,alt:!0}),ft=i(s),T=p(s,"H2",{class:!0});var Mn=r(T);H=p(Mn,"A",{id:!0,class:!0,href:!0});var Bl=r(H);ya=p(Bl,"SPAN",{});var Fl=r(ya);Pe(is.$$.fragment,Fl),Fl.forEach(a),Bl.forEach(a),Zn=i(Mn),Zs=p(Mn,"SPAN",{"data-svelte-h":!0}),g(Zs)!=="svelte-6jn1te"&&(Zs.textContent=gl),Mn.forEach(a),wt=i(s),f=p(s,"P",{});var V=r(f);sa=p(V,"STRONG",{});var Se=r(sa);se=h(Se,"Temporal Difference, on the other hand, waits for only one interaction (one step) "),xt=v(Se,!1),Se.forEach(a),ae=h(V," to form a TD target and update "),bt=v(V,!1),_t=h(V," using "),Mt=v(V,!1),zt=h(V," and "),kt=v(V,!1),Lt=h(V,"."),V.forEach(a),St=i(s),rs=p(s,"P",{});var Te=r(rs);te=h(Te,"The idea with "),cs=p(Te,"STRONG",{});var zn=r(cs);ne=h(zn,"TD is to update the "),Tt=v(zn,!1),Ct=h(zn," at each step."),zn.forEach(a),Te.forEach(a),Gt=i(s),C=p(s,"P",{});var ba=r(C);ee=h(ba,"But because we didn’t experience an entire episode, we don’t have "),Et=v(ba,!1),Vt=h(ba," (expected return). Instead, "),G=p(ba,"STRONG",{});var ha=r(G);le=h(ha,"we estimate "),Rt=v(ha,!1),Pt=h(ha," by adding "),Ht=v(ha,!1),It=h(ha," and the discounted value of the next state."),ha.forEach(a),ba.forEach(a),Dt=i(s),hs=p(s,"P",{});var Ce=r(hs);pe=h(Ce,"This is called bootstrapping. It’s called this "),E=p(Ce,"STRONG",{});var oa=r(E);me=h(oa,"because TD bases its update in part on an existing estimate "),Nt=v(oa,!1),$t=h(oa," and not a complete sample "),jt=v(oa,!1),Ot=h(oa,"."),oa.forEach(a),Ce.forEach(a),At=i(s),os=p(s,"IMG",{src:!0,alt:!0}),Wt=i(s),gs=p(s,"P",{"data-svelte-h":!0}),g(gs)!=="svelte-1a7834f"&&(gs.innerHTML=vl),qt=i(s),us=p(s,"IMG",{src:!0,alt:!0}),Ut=i(s),vs=p(s,"P",{"data-svelte-h":!0}),g(vs)!=="svelte-1ijk2ql"&&(vs.textContent=yl),Bt=i(s),ds=p(s,"IMG",{src:!0,alt:!0}),Ft=i(s),x=p(s,"UL",{});var $=r(x);aa=p($,"LI",{"data-svelte-h":!0}),g(aa)!=="svelte-1uhtcgd"&&(aa.innerHTML=wl),ie=i($),ta=p($,"LI",{"data-svelte-h":!0}),g(ta)!=="svelte-1hykgj"&&(ta.innerHTML=xl),re=i($),na=p($,"LI",{"data-svelte-h":!0}),g(na)!=="svelte-toxj8r"&&(na.innerHTML=bl),ce=i($),ys=p($,"LI",{});var kn=r(ys);I=p(kn,"P",{});var _a=r(I);he=h(_a,"It gets a reward  "),Jt=v(_a,!1),Qt=h(_a," since "),ea=p(_a,"STRONG",{"data-svelte-h":!0}),g(ea)!=="svelte-1cpiv0b"&&(ea.textContent=_l),_a.forEach(a),oe=i(kn),la=p(kn,"IMG",{src:!0,alt:!0}),kn.forEach(a),$.forEach(a),Kt=i(s),fs=p(s,"IMG",{src:!0,alt:!0}),Xt=i(s),D=p(s,"P",{});var Ln=r(D);ge=h(Ln,"We can now update  "),Yt=v(Ln,!1),Zt=h(Ln,":"),Ln.forEach(a),sn=i(s),ws=p(s,"P",{});var Ge=r(ws);ue=h(Ge,"New  "),an=v(Ge,!1),Ge.forEach(a),tn=i(s),xs=p(s,"P",{});var Ee=r(xs);ve=h(Ee,"New "),nn=v(Ee,!1),Ee.forEach(a),en=i(s),bs=p(s,"P",{});var Ve=r(bs);de=h(Ve,"New "),ln=v(Ve,!1),Ve.forEach(a),pn=i(s),_s=p(s,"P",{"data-svelte-h":!0}),g(_s)!=="svelte-9mnez4"&&(_s.textContent=kl),mn=i(s),Ms=p(s,"P",{"data-svelte-h":!0}),g(Ms)!=="svelte-114rjrk"&&(Ms.innerHTML=Ll),rn=i(s),zs=p(s,"IMG",{src:!0,alt:!0}),cn=i(s),ks=p(s,"P",{"data-svelte-h":!0}),g(ks)!=="svelte-gcetae"&&(ks.textContent=Tl),hn=i(s),N=p(s,"UL",{});var Sn=r(N);pa=p(Sn,"LI",{"data-svelte-h":!0}),g(pa)!=="svelte-17v3eqc"&&(pa.innerHTML=Cl),ye=i(Sn),Ls=p(Sn,"LI",{});var Tn=r(Ls);b=p(Tn,"P",{});var Ss=r(b);fe=h(Ss,"With "),ma=p(Ss,"EM",{"data-svelte-h":!0}),g(ma)!=="svelte-1kiwr2w"&&(ma.textContent=Gl),we=h(Ss,", we update the value function from a step, and we replace "),on=v(Ss,!1),gn=h(Ss,", which we don’t know, with "),ia=p(Ss,"STRONG",{"data-svelte-h":!0}),g(ia)!=="svelte-vbrp5s"&&(ia.textContent=El),Ss.forEach(a),xe=i(Tn),ra=p(Tn,"IMG",{src:!0,alt:!0}),Tn.forEach(a),Sn.forEach(a),un=i(s),fa=p(s,"P",{}),r(fa).forEach(a),this.h()},h(){o(_,"name","hf:doc:metadata"),o(_,"content",JSON.stringify(Ep)),o(R,"id","mc-vs-td"),o(R,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(R,"href","#mc-vs-td"),o(M,"class","relative group"),Ca.a=Ga,o(P,"id","monte-carlo"),o(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(P,"href","#monte-carlo"),o(k,"class","relative group"),Pa.a=Ha,Ia.a=Da,w(Q.src,Qe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/monte-carlo-approach.jpg")||o(Q,"src",Qe),o(Q,"alt","Monte Carlo"),w(X.src,Xe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-2.jpg")||o(X,"src",Xe),o(X,"alt","Monte Carlo"),Wa.a=null,qa.a=Ua,w($s.src,nl="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-3.jpg")||o($s,"src",nl),o($s,"alt","Monte Carlo"),w(as.src,pl="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-3p.jpg")||o(as,"src",pl),o(as,"alt","Monte Carlo"),Ya.a=null,st.a=at,nt.a=null,lt.a=null,mt.a=null,rt.a=ct,w(Qs.src,hl="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-5.jpg")||o(Qs,"src",hl),o(Qs,"alt","Monte Carlo"),ot.a=null,ut.a=null,dt.a=null,w(ms.src,ol="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/MC-5p.jpg")||o(ms,"src",ol),o(ms,"alt","Monte Carlo"),o(H,"id","td-learning"),o(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(H,"href","#td-learning"),o(T,"class","relative group"),xt.a=null,bt.a=_t,Mt.a=zt,kt.a=Lt,Tt.a=Ct,Et.a=Vt,Rt.a=Pt,Ht.a=It,Nt.a=$t,jt.a=Ot,w(os.src,ul="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-1.jpg")||o(os,"src",ul),o(os,"alt","Temporal Difference"),w(us.src,dl="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-1p.jpg")||o(us,"src",dl),o(us,"alt","Temporal Difference"),w(ds.src,fl="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-2.jpg")||o(ds,"src",fl),o(ds,"alt","Temporal Difference"),Jt.a=Qt,w(la.src,Ml="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-2p.jpg")||o(la,"src",Ml),o(la,"alt","Temporal Difference"),w(fs.src,zl="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-3.jpg")||o(fs,"src",zl),o(fs,"alt","Temporal Difference"),Yt.a=Zt,an.a=null,nn.a=null,ln.a=null,w(zs.src,Sl="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/TD-3p.jpg")||o(zs,"src",Sl),o(zs,"alt","Temporal Difference"),on.a=gn,w(ra.src,Vl="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Summary.jpg")||o(ra,"src",Vl),o(ra,"alt","Summary")},m(s,n){t(document.head,_),e(s,Ma,n),e(s,ga,n),e(s,za,n),e(s,M,n),t(M,R),t(R,ua),He(j,ua,null),t(M,Cn),t(M,Ts),e(s,ka,n),e(s,O,n),e(s,La,n),e(s,A,n),e(s,Sa,n),e(s,W,n),e(s,Ta,n),e(s,z,n),t(z,Gn),t(z,Cs),t(z,En),t(z,q),t(q,Vn),Ca.m(Jl,q),t(q,Ga),e(s,Ea,n),e(s,U,n),e(s,Va,n),e(s,k,n),t(k,P),t(P,va),He(B,va,null),t(k,Rn),t(k,Gs),e(s,Ra,n),e(s,L,n),t(L,Pn),Pa.m(Ql,L),t(L,Ha),t(L,F),t(F,Hn),Ia.m(Kl,F),t(F,Da),e(s,Na,n),e(s,J,n),e(s,$a,n),e(s,Q,n),e(s,ja,n),e(s,K,n),e(s,Oa,n),e(s,X,n),e(s,Aa,n),e(s,d,n),t(d,Es),t(d,In),t(d,Vs),t(d,Dn),t(d,Rs),t(d,Nn),t(d,Ps),t(d,$n),t(d,Hs),t(d,jn),t(d,da),t(da,Is),t(Is,Ds),t(Ds,On),Wa.m(Xl,Ds),t(Is,An),t(d,Wn),t(d,Y),t(Y,Ns),t(Ns,qn),t(Ns,Z),t(Z,Un),qa.m(Yl,Z),t(Z,Ua),t(Y,Bn),t(Y,$s),t(d,Fn),t(d,js),e(s,Ba,n),e(s,ss,n),e(s,Fa,n),e(s,as,n),e(s,Ja,n),e(s,ts,n),e(s,Qa,n),e(s,ns,n),e(s,Ka,n),e(s,es,n),e(s,Xa,n),e(s,Os,n),t(Os,As),t(As,Jn),t(As,Ws),t(Ws,Qn),Ya.m(Zl,Ws),e(s,Za,n),e(s,ls,n),st.m(sp,ls),t(ls,at),e(s,tt,n),e(s,qs,n),nt.m(ap,qs),e(s,et,n),e(s,Us,n),lt.m(tp,Us),e(s,pt,n),e(s,Bs,n),mt.m(np,Bs),e(s,it,n),e(s,Fs,n),t(Fs,ps),t(ps,S),t(S,Kn),t(S,Js),t(S,Xn),rt.m(ep,S),t(S,ct),t(ps,Yn),t(ps,Qs),e(s,ht,n),e(s,Ks,n),ot.m(lp,Ks),e(s,gt,n),e(s,Xs,n),ut.m(pp,Xs),e(s,vt,n),e(s,Ys,n),dt.m(mp,Ys),e(s,yt,n),e(s,ms,n),e(s,ft,n),e(s,T,n),t(T,H),t(H,ya),He(is,ya,null),t(T,Zn),t(T,Zs),e(s,wt,n),e(s,f,n),t(f,sa),t(sa,se),xt.m(ip,sa),t(f,ae),bt.m(rp,f),t(f,_t),Mt.m(cp,f),t(f,zt),kt.m(hp,f),t(f,Lt),e(s,St,n),e(s,rs,n),t(rs,te),t(rs,cs),t(cs,ne),Tt.m(op,cs),t(cs,Ct),e(s,Gt,n),e(s,C,n),t(C,ee),Et.m(gp,C),t(C,Vt),t(C,G),t(G,le),Rt.m(up,G),t(G,Pt),Ht.m(vp,G),t(G,It),e(s,Dt,n),e(s,hs,n),t(hs,pe),t(hs,E),t(E,me),Nt.m(dp,E),t(E,$t),jt.m(yp,E),t(E,Ot),e(s,At,n),e(s,os,n),e(s,Wt,n),e(s,gs,n),e(s,qt,n),e(s,us,n),e(s,Ut,n),e(s,vs,n),e(s,Bt,n),e(s,ds,n),e(s,Ft,n),e(s,x,n),t(x,aa),t(x,ie),t(x,ta),t(x,re),t(x,na),t(x,ce),t(x,ys),t(ys,I),t(I,he),Jt.m(fp,I),t(I,Qt),t(I,ea),t(ys,oe),t(ys,la),e(s,Kt,n),e(s,fs,n),e(s,Xt,n),e(s,D,n),t(D,ge),Yt.m(wp,D),t(D,Zt),e(s,sn,n),e(s,ws,n),t(ws,ue),an.m(xp,ws),e(s,tn,n),e(s,xs,n),t(xs,ve),nn.m(bp,xs),e(s,en,n),e(s,bs,n),t(bs,de),ln.m(_p,bs),e(s,pn,n),e(s,_s,n),e(s,mn,n),e(s,Ms,n),e(s,rn,n),e(s,zs,n),e(s,cn,n),e(s,ks,n),e(s,hn,n),e(s,N,n),t(N,pa),t(N,ye),t(N,Ls),t(Ls,b),t(b,fe),t(b,ma),t(b,we),on.m(Mp,b),t(b,gn),t(b,ia),t(Ls,xe),t(Ls,ra),e(s,un,n),e(s,fa,n),vn=!0},p:kp,i(s){vn||(Ie(j.$$.fragment,s),Ie(B.$$.fragment,s),Ie(is.$$.fragment,s),vn=!0)},o(s){De(j.$$.fragment,s),De(B.$$.fragment,s),De(is.$$.fragment,s),vn=!1},d(s){s&&(a(Ma),a(ga),a(za),a(M),a(ka),a(O),a(La),a(A),a(Sa),a(W),a(Ta),a(z),a(Ea),a(U),a(Va),a(k),a(Ra),a(L),a(Na),a(J),a($a),a(Q),a(ja),a(K),a(Oa),a(X),a(Aa),a(d),a(Ba),a(ss),a(Fa),a(as),a(Ja),a(ts),a(Qa),a(ns),a(Ka),a(es),a(Xa),a(Os),a(Za),a(ls),a(tt),a(qs),a(et),a(Us),a(pt),a(Bs),a(it),a(Fs),a(ht),a(Ks),a(gt),a(Xs),a(vt),a(Ys),a(yt),a(ms),a(ft),a(T),a(wt),a(f),a(St),a(rs),a(Gt),a(C),a(Dt),a(hs),a(At),a(os),a(Wt),a(gs),a(qt),a(us),a(Ut),a(vs),a(Bt),a(ds),a(Ft),a(x),a(Kt),a(fs),a(Xt),a(D),a(sn),a(ws),a(tn),a(xs),a(en),a(bs),a(pn),a(_s),a(mn),a(Ms),a(rn),a(zs),a(cn),a(ks),a(hn),a(N),a(un),a(fa)),a(_),Ne(j),Ne(B),Ne(is)}}}const Ep={local:"mc-vs-td",sections:[{local:"monte-carlo",title:"Monte Carlo: learning at the end of the episode "},{local:"td-learning",title:"Temporal Difference Learning: learning at each step "}],title:"Monte Carlo vs Temporal Difference Learning "};function Vp(je){return Lp(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ip extends Sp{constructor(_){super(),Tp(this,_,Vp,Gp,zp,{})}}export{Ip as component};
