import{s as ga,n as ma,o as ya}from"../chunks/scheduler.37c15a92.js";import{S as wa,i as xa,g as i,s,u as le,A as _a,h as l,f as t,c as o,j as p,v as se,y as h,k as r,o as c,a as n,w as oe,d as re,t as he,x as ce}from"../chunks/index.b01106c0.js";import{I as pe}from"../chunks/IconCopyLink.77b762b4.js";function Ca(bt){let u,Te,we,Le,v,x,xe,M,gt,ue,$t="The advantages and disadvantages of policy-gradient methods",Me,E,Pt="At this point, you might ask, “but Deep Q-Learning is excellent! Why use policy-gradient methods?“. To answer this question, let’s study the <strong>advantages and disadvantages of policy-gradient methods</strong>.",Ee,d,_,_e,A,mt,ve,kt="Advantages",Ae,S,Ht="There are multiple advantages over value-based methods. Let’s see some of them:",Se,f,C,Ce,N,yt,de,Tt="The simplicity of integration",Ne,q,Lt="We can estimate the policy directly without storing additional data (action values).",qe,g,b,be,j,wt,fe,Mt="Policy-gradient methods can learn a stochastic policy",je,z,Et="Policy-gradient methods can <strong>learn a stochastic policy while value functions can’t</strong>.",ze,I,At="This has two consequences:",Ie,U,St="<li><p>We <strong>don’t need to implement an exploration/exploitation trade-off by hand</strong>. Since we output a probability distribution over actions, the agent explores <strong>the state space without always taking the same trajectory.</strong></p></li> <li><p>We also get rid of the problem of <strong>perceptual aliasing</strong>. Perceptual aliasing is when two states seem (or are) the same but need different actions.</p></li>",Ue,F,Nt="Let’s take an example: we have an intelligent vacuum cleaner whose goal is to suck the dust and avoid killing the hamsters.",Fe,$,qt='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/hamster1.jpg" alt="Hamster 1"/>',Oe,O,jt="Our vacuum cleaner can only perceive where the walls are.",Qe,Q,zt="The problem is that the <strong>two red (colored) states are aliased states because the agent perceives an upper and lower wall for each</strong>.",We,P,It='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/hamster2.jpg" alt="Hamster 1"/>',Re,W,Ut="Under a deterministic policy, the policy will either always move right when in a red state or always move left. <strong>Either case will cause our agent to get stuck and never suck the dust</strong>.",De,R,Ft="Under a value-based Reinforcement learning algorithm, we learn a <strong>quasi-deterministic policy</strong> (“greedy epsilon strategy”). Consequently, our agent can <strong>spend a lot of time before finding the dust</strong>.",Ge,D,Ot="On the other hand, an optimal stochastic policy <strong>will randomly move left or right in red (colored) states</strong>. Consequently, <strong>it will not be stuck and will reach the goal state with a high probability</strong>.",Be,k,Qt='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit6/hamster3.jpg" alt="Hamster 1"/>',Je,m,H,$e,G,xt,ge,Wt="Policy-gradient methods are more effective in high-dimensional action spaces and continuous actions spaces",Ke,B,Rt="The problem with Deep Q-learning is that their <strong>predictions assign a score (maximum expected future reward) for each possible action</strong>, at each time step, given the current state.",Ve,J,Dt="But what if we have an infinite possibility of actions?",Xe,K,Gt="For instance, with a self-driving car, at each state, you can have a (near) infinite choice of actions (turning the wheel at 15°, 17.2°, 19,4°, honking, etc.). <strong>We’ll need to output a Q-value for each possible action</strong>! And <strong>taking the max action of a continuous output is an optimization problem itself</strong>!",Ye,V,Bt="Instead, with policy-gradient methods, we output a <strong>probability distribution over actions.</strong>",Ze,y,T,Pe,X,_t,me,Jt="Policy-gradient methods have better convergence properties",et,Y,Kt=`In value-based methods, we use an aggressive operator to <strong>change the value function: we take the maximum over Q-estimates</strong>.
Consequently, the action probabilities may change dramatically for an arbitrarily small change in the estimated action values if that change results in a different action having the maximal value.`,tt,Z,Vt="For instance, if during the training, the best action was left (with a Q-value of 0.22) and the training step after it’s right (since the right Q-value becomes 0.23), we dramatically changed the policy since now the policy will take most of the time right instead of left.",at,ee,Xt="On the other hand, in policy-gradient methods, stochastic policy action preferences (probability of taking action) <strong>change smoothly over time</strong>.",nt,w,L,ke,te,Ct,ye,Yt="Disadvantages",it,ae,Zt="Naturally, policy-gradient methods also have some disadvantages:",lt,ne,ea="<li><strong>Frequently, policy-gradient methods converges to a local maximum instead of a global optimum.</strong></li> <li>Policy-gradient goes slower, <strong>step by step: it can take longer to train (inefficient).</strong></li> <li>Policy-gradient can have high variance. We’ll see in the actor-critic unit why, and how we can solve this problem.</li>",st,ie,ta='👉 If you want to go deeper into the advantages and disadvantages of policy-gradient methods, <a href="https://youtu.be/y3oqOjHilio" rel="nofollow">you can check this video</a>.',ot,He,rt;return M=new pe({}),A=new pe({}),N=new pe({}),j=new pe({}),G=new pe({}),X=new pe({}),te=new pe({}),{c(){u=i("meta"),Te=s(),we=i("p"),Le=s(),v=i("h1"),x=i("a"),xe=i("span"),le(M.$$.fragment),gt=s(),ue=i("span"),ue.textContent=$t,Me=s(),E=i("p"),E.innerHTML=Pt,Ee=s(),d=i("h2"),_=i("a"),_e=i("span"),le(A.$$.fragment),mt=s(),ve=i("span"),ve.textContent=kt,Ae=s(),S=i("p"),S.textContent=Ht,Se=s(),f=i("h3"),C=i("a"),Ce=i("span"),le(N.$$.fragment),yt=s(),de=i("span"),de.textContent=Tt,Ne=s(),q=i("p"),q.textContent=Lt,qe=s(),g=i("h3"),b=i("a"),be=i("span"),le(j.$$.fragment),wt=s(),fe=i("span"),fe.textContent=Mt,je=s(),z=i("p"),z.innerHTML=Et,ze=s(),I=i("p"),I.textContent=At,Ie=s(),U=i("ol"),U.innerHTML=St,Ue=s(),F=i("p"),F.textContent=Nt,Fe=s(),$=i("figure"),$.innerHTML=qt,Oe=s(),O=i("p"),O.textContent=jt,Qe=s(),Q=i("p"),Q.innerHTML=zt,We=s(),P=i("figure"),P.innerHTML=It,Re=s(),W=i("p"),W.innerHTML=Ut,De=s(),R=i("p"),R.innerHTML=Ft,Ge=s(),D=i("p"),D.innerHTML=Ot,Be=s(),k=i("figure"),k.innerHTML=Qt,Je=s(),m=i("h3"),H=i("a"),$e=i("span"),le(G.$$.fragment),xt=s(),ge=i("span"),ge.textContent=Wt,Ke=s(),B=i("p"),B.innerHTML=Rt,Ve=s(),J=i("p"),J.textContent=Dt,Xe=s(),K=i("p"),K.innerHTML=Gt,Ye=s(),V=i("p"),V.innerHTML=Bt,Ze=s(),y=i("h3"),T=i("a"),Pe=i("span"),le(X.$$.fragment),_t=s(),me=i("span"),me.textContent=Jt,et=s(),Y=i("p"),Y.innerHTML=Kt,tt=s(),Z=i("p"),Z.textContent=Vt,at=s(),ee=i("p"),ee.innerHTML=Xt,nt=s(),w=i("h2"),L=i("a"),ke=i("span"),le(te.$$.fragment),Ct=s(),ye=i("span"),ye.textContent=Yt,it=s(),ae=i("p"),ae.textContent=Zt,lt=s(),ne=i("ul"),ne.innerHTML=ea,st=s(),ie=i("p"),ie.innerHTML=ta,ot=s(),He=i("p"),this.h()},l(e){const a=_a("svelte-1phssyn",document.head);u=l(a,"META",{name:!0,content:!0}),a.forEach(t),Te=o(e),we=l(e,"P",{}),p(we).forEach(t),Le=o(e),v=l(e,"H1",{class:!0});var ht=p(v);x=l(ht,"A",{id:!0,class:!0,href:!0});var aa=p(x);xe=l(aa,"SPAN",{});var na=p(xe);se(M.$$.fragment,na),na.forEach(t),aa.forEach(t),gt=o(ht),ue=l(ht,"SPAN",{"data-svelte-h":!0}),h(ue)!=="svelte-1g6k9t5"&&(ue.textContent=$t),ht.forEach(t),Me=o(e),E=l(e,"P",{"data-svelte-h":!0}),h(E)!=="svelte-tdbzv5"&&(E.innerHTML=Pt),Ee=o(e),d=l(e,"H2",{class:!0});var ct=p(d);_=l(ct,"A",{id:!0,class:!0,href:!0});var ia=p(_);_e=l(ia,"SPAN",{});var la=p(_e);se(A.$$.fragment,la),la.forEach(t),ia.forEach(t),mt=o(ct),ve=l(ct,"SPAN",{"data-svelte-h":!0}),h(ve)!=="svelte-1htwcxv"&&(ve.textContent=kt),ct.forEach(t),Ae=o(e),S=l(e,"P",{"data-svelte-h":!0}),h(S)!=="svelte-maw3p6"&&(S.textContent=Ht),Se=o(e),f=l(e,"H3",{class:!0});var pt=p(f);C=l(pt,"A",{id:!0,class:!0,href:!0});var sa=p(C);Ce=l(sa,"SPAN",{});var oa=p(Ce);se(N.$$.fragment,oa),oa.forEach(t),sa.forEach(t),yt=o(pt),de=l(pt,"SPAN",{"data-svelte-h":!0}),h(de)!=="svelte-wdmhc0"&&(de.textContent=Tt),pt.forEach(t),Ne=o(e),q=l(e,"P",{"data-svelte-h":!0}),h(q)!=="svelte-2fsuyn"&&(q.textContent=Lt),qe=o(e),g=l(e,"H3",{class:!0});var ut=p(g);b=l(ut,"A",{id:!0,class:!0,href:!0});var ra=p(b);be=l(ra,"SPAN",{});var ha=p(be);se(j.$$.fragment,ha),ha.forEach(t),ra.forEach(t),wt=o(ut),fe=l(ut,"SPAN",{"data-svelte-h":!0}),h(fe)!=="svelte-1ggnm1u"&&(fe.textContent=Mt),ut.forEach(t),je=o(e),z=l(e,"P",{"data-svelte-h":!0}),h(z)!=="svelte-1e82bsg"&&(z.innerHTML=Et),ze=o(e),I=l(e,"P",{"data-svelte-h":!0}),h(I)!=="svelte-1dwxfce"&&(I.textContent=At),Ie=o(e),U=l(e,"OL",{"data-svelte-h":!0}),h(U)!=="svelte-3l8e2h"&&(U.innerHTML=St),Ue=o(e),F=l(e,"P",{"data-svelte-h":!0}),h(F)!=="svelte-hzq0kh"&&(F.textContent=Nt),Fe=o(e),$=l(e,"FIGURE",{class:!0,"data-svelte-h":!0}),h($)!=="svelte-juzukv"&&($.innerHTML=qt),Oe=o(e),O=l(e,"P",{"data-svelte-h":!0}),h(O)!=="svelte-sba7bj"&&(O.textContent=jt),Qe=o(e),Q=l(e,"P",{"data-svelte-h":!0}),h(Q)!=="svelte-14k1z7"&&(Q.innerHTML=zt),We=o(e),P=l(e,"FIGURE",{class:!0,"data-svelte-h":!0}),h(P)!=="svelte-zv8qjk"&&(P.innerHTML=It),Re=o(e),W=l(e,"P",{"data-svelte-h":!0}),h(W)!=="svelte-wo6gfi"&&(W.innerHTML=Ut),De=o(e),R=l(e,"P",{"data-svelte-h":!0}),h(R)!=="svelte-h0f6wc"&&(R.innerHTML=Ft),Ge=o(e),D=l(e,"P",{"data-svelte-h":!0}),h(D)!=="svelte-140fl91"&&(D.innerHTML=Ot),Be=o(e),k=l(e,"FIGURE",{class:!0,"data-svelte-h":!0}),h(k)!=="svelte-y1qp89"&&(k.innerHTML=Qt),Je=o(e),m=l(e,"H3",{class:!0});var vt=p(m);H=l(vt,"A",{id:!0,class:!0,href:!0});var ca=p(H);$e=l(ca,"SPAN",{});var pa=p($e);se(G.$$.fragment,pa),pa.forEach(t),ca.forEach(t),xt=o(vt),ge=l(vt,"SPAN",{"data-svelte-h":!0}),h(ge)!=="svelte-j1scry"&&(ge.textContent=Wt),vt.forEach(t),Ke=o(e),B=l(e,"P",{"data-svelte-h":!0}),h(B)!=="svelte-1mhp325"&&(B.innerHTML=Rt),Ve=o(e),J=l(e,"P",{"data-svelte-h":!0}),h(J)!=="svelte-19u4xo5"&&(J.textContent=Dt),Xe=o(e),K=l(e,"P",{"data-svelte-h":!0}),h(K)!=="svelte-od3dsl"&&(K.innerHTML=Gt),Ye=o(e),V=l(e,"P",{"data-svelte-h":!0}),h(V)!=="svelte-6wxwpi"&&(V.innerHTML=Bt),Ze=o(e),y=l(e,"H3",{class:!0});var dt=p(y);T=l(dt,"A",{id:!0,class:!0,href:!0});var ua=p(T);Pe=l(ua,"SPAN",{});var va=p(Pe);se(X.$$.fragment,va),va.forEach(t),ua.forEach(t),_t=o(dt),me=l(dt,"SPAN",{"data-svelte-h":!0}),h(me)!=="svelte-1wbwq6s"&&(me.textContent=Jt),dt.forEach(t),et=o(e),Y=l(e,"P",{"data-svelte-h":!0}),h(Y)!=="svelte-1ewv4ss"&&(Y.innerHTML=Kt),tt=o(e),Z=l(e,"P",{"data-svelte-h":!0}),h(Z)!=="svelte-xfh67p"&&(Z.textContent=Vt),at=o(e),ee=l(e,"P",{"data-svelte-h":!0}),h(ee)!=="svelte-1nkvz6"&&(ee.innerHTML=Xt),nt=o(e),w=l(e,"H2",{class:!0});var ft=p(w);L=l(ft,"A",{id:!0,class:!0,href:!0});var da=p(L);ke=l(da,"SPAN",{});var fa=p(ke);se(te.$$.fragment,fa),fa.forEach(t),da.forEach(t),Ct=o(ft),ye=l(ft,"SPAN",{"data-svelte-h":!0}),h(ye)!=="svelte-1tpfjz1"&&(ye.textContent=Yt),ft.forEach(t),it=o(e),ae=l(e,"P",{"data-svelte-h":!0}),h(ae)!=="svelte-1fe6jwi"&&(ae.textContent=Zt),lt=o(e),ne=l(e,"UL",{"data-svelte-h":!0}),h(ne)!=="svelte-posk1q"&&(ne.innerHTML=ea),st=o(e),ie=l(e,"P",{"data-svelte-h":!0}),h(ie)!=="svelte-s99z02"&&(ie.innerHTML=ta),ot=o(e),He=l(e,"P",{}),p(He).forEach(t),this.h()},h(){r(u,"name","hf:doc:metadata"),r(u,"content",JSON.stringify(ba)),r(x,"id","the-advantages-and-disadvantages-of-policygradient-methods"),r(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(x,"href","#the-advantages-and-disadvantages-of-policygradient-methods"),r(v,"class","relative group"),r(_,"id","advantages"),r(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(_,"href","#advantages"),r(d,"class","relative group"),r(C,"id","the-simplicity-of-integration"),r(C,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(C,"href","#the-simplicity-of-integration"),r(f,"class","relative group"),r(b,"id","policygradient-methods-can-learn-a-stochastic-policy"),r(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(b,"href","#policygradient-methods-can-learn-a-stochastic-policy"),r(g,"class","relative group"),r($,"class","image table text-center m-0 w-full"),r(P,"class","image table text-center m-0 w-full"),r(k,"class","image table text-center m-0 w-full"),r(H,"id","policygradient-methods-are-more-effective-in-highdimensional-action-spaces-and-continuous-actions-spaces"),r(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(H,"href","#policygradient-methods-are-more-effective-in-highdimensional-action-spaces-and-continuous-actions-spaces"),r(m,"class","relative group"),r(T,"id","policygradient-methods-have-better-convergence-properties"),r(T,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(T,"href","#policygradient-methods-have-better-convergence-properties"),r(y,"class","relative group"),r(L,"id","disadvantages"),r(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(L,"href","#disadvantages"),r(w,"class","relative group")},m(e,a){c(document.head,u),n(e,Te,a),n(e,we,a),n(e,Le,a),n(e,v,a),c(v,x),c(x,xe),oe(M,xe,null),c(v,gt),c(v,ue),n(e,Me,a),n(e,E,a),n(e,Ee,a),n(e,d,a),c(d,_),c(_,_e),oe(A,_e,null),c(d,mt),c(d,ve),n(e,Ae,a),n(e,S,a),n(e,Se,a),n(e,f,a),c(f,C),c(C,Ce),oe(N,Ce,null),c(f,yt),c(f,de),n(e,Ne,a),n(e,q,a),n(e,qe,a),n(e,g,a),c(g,b),c(b,be),oe(j,be,null),c(g,wt),c(g,fe),n(e,je,a),n(e,z,a),n(e,ze,a),n(e,I,a),n(e,Ie,a),n(e,U,a),n(e,Ue,a),n(e,F,a),n(e,Fe,a),n(e,$,a),n(e,Oe,a),n(e,O,a),n(e,Qe,a),n(e,Q,a),n(e,We,a),n(e,P,a),n(e,Re,a),n(e,W,a),n(e,De,a),n(e,R,a),n(e,Ge,a),n(e,D,a),n(e,Be,a),n(e,k,a),n(e,Je,a),n(e,m,a),c(m,H),c(H,$e),oe(G,$e,null),c(m,xt),c(m,ge),n(e,Ke,a),n(e,B,a),n(e,Ve,a),n(e,J,a),n(e,Xe,a),n(e,K,a),n(e,Ye,a),n(e,V,a),n(e,Ze,a),n(e,y,a),c(y,T),c(T,Pe),oe(X,Pe,null),c(y,_t),c(y,me),n(e,et,a),n(e,Y,a),n(e,tt,a),n(e,Z,a),n(e,at,a),n(e,ee,a),n(e,nt,a),n(e,w,a),c(w,L),c(L,ke),oe(te,ke,null),c(w,Ct),c(w,ye),n(e,it,a),n(e,ae,a),n(e,lt,a),n(e,ne,a),n(e,st,a),n(e,ie,a),n(e,ot,a),n(e,He,a),rt=!0},p:ma,i(e){rt||(re(M.$$.fragment,e),re(A.$$.fragment,e),re(N.$$.fragment,e),re(j.$$.fragment,e),re(G.$$.fragment,e),re(X.$$.fragment,e),re(te.$$.fragment,e),rt=!0)},o(e){he(M.$$.fragment,e),he(A.$$.fragment,e),he(N.$$.fragment,e),he(j.$$.fragment,e),he(G.$$.fragment,e),he(X.$$.fragment,e),he(te.$$.fragment,e),rt=!1},d(e){e&&(t(Te),t(we),t(Le),t(v),t(Me),t(E),t(Ee),t(d),t(Ae),t(S),t(Se),t(f),t(Ne),t(q),t(qe),t(g),t(je),t(z),t(ze),t(I),t(Ie),t(U),t(Ue),t(F),t(Fe),t($),t(Oe),t(O),t(Qe),t(Q),t(We),t(P),t(Re),t(W),t(De),t(R),t(Ge),t(D),t(Be),t(k),t(Je),t(m),t(Ke),t(B),t(Ve),t(J),t(Xe),t(K),t(Ye),t(V),t(Ze),t(y),t(et),t(Y),t(tt),t(Z),t(at),t(ee),t(nt),t(w),t(it),t(ae),t(lt),t(ne),t(st),t(ie),t(ot),t(He)),t(u),ce(M),ce(A),ce(N),ce(j),ce(G),ce(X),ce(te)}}}const ba={local:"the-advantages-and-disadvantages-of-policygradient-methods",sections:[{local:"advantages",sections:[{local:"the-simplicity-of-integration",title:"The simplicity of integration"},{local:"policygradient-methods-can-learn-a-stochastic-policy",title:"Policy-gradient methods can learn a stochastic policy"},{local:"policygradient-methods-are-more-effective-in-highdimensional-action-spaces-and-continuous-actions-spaces",title:"Policy-gradient methods are more effective in high-dimensional action spaces and continuous actions spaces"},{local:"policygradient-methods-have-better-convergence-properties",title:"Policy-gradient methods have better convergence properties"}],title:"Advantages"},{local:"disadvantages",title:"Disadvantages"}],title:"The advantages and disadvantages of policy-gradient methods"};function $a(bt){return ya(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ta extends wa{constructor(u){super(),xa(this,u,$a,Ca,ga,{})}}export{Ta as component};
