import{s as Cs,f as xs,n as ks,o as As}from"../chunks/scheduler.37c15a92.js";import{S as bs,i as Ps,g as n,s as r,u as ae,m as c,H as xt,A as Es,h as a,f as e,c as o,j as p,v as le,y as m,n as g,B as yt,k as h,o as l,a as i,w as ie,d as re,t as oe,x as pe}from"../chunks/index.b01106c0.js";import{I as he}from"../chunks/IconCopyLink.77b762b4.js";function Hs(Ge){let v,_t,gt,Lt,f,M,ut,H,me,X,Oe="How do Unity ML-Agents work?",Tt,S,qe="Before training our agent, we need to understand <strong>what ML-Agents is and how it works</strong>.",Mt,d,C,vt,$,ce,Y,je="What is Unity ML-Agents?",Ct,R,Fe='<a href="https://github.com/Unity-Technologies/ml-agents" rel="nofollow">Unity ML-Agents</a> is a toolkit for the game engine Unity that <strong>allows us to create environments using Unity or use pre-made environments to train our agents</strong>.',kt,U,Be='It’s developed by <a href="https://unity.com/" rel="nofollow">Unity Technologies</a>, the developers of Unity, one of the most famous Game Engines used by the creators of Firewatch, Cuphead, and Cities: Skylines.',At,I,We='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/firewatch.jpeg" alt="Firewatch"/> <figcaption>Firewatch was made with Unity</figcaption>',bt,w,k,ft,z,ge,tt,Ze="The six components",Pt,N,De="With Unity ML-Agents, you have six essential components:",Et,G,Je='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/mlagents-1.png" alt="MLAgents"/> <figcaption>Source: <a href="https://unity-technologies.github.io/ml-agents/">Unity ML-Agents Documentation</a></figcaption>',Ht,O,Ke="<li>The first is the <em>Learning Environment</em>, which contains <strong>the Unity scene (the environment) and the environment elements</strong> (game characters).</li> <li>The second is the <em>Python Low-level API</em>, which contains <strong>the low-level Python interface for interacting and manipulating the environment</strong>. It’s the API we use to launch the training.</li> <li>Then, we have the <em>External Communicator</em> that <strong>connects the Learning Environment (made with C#) with the low level Python API (Python)</strong>.</li> <li>The <em>Python trainers</em>: the <strong>Reinforcement algorithms made with PyTorch (PPO, SAC…)</strong>.</li> <li>The <em>Gym wrapper</em>: to encapsulate the RL environment in a gym wrapper.</li> <li>The <em>PettingZoo wrapper</em>: PettingZoo is the multi-agents version of the gym wrapper.</li>",St,x,A,dt,q,ue,et,Qe="Inside the Learning Component",$t,j,Ve="Inside the Learning Component, we have <strong>two important elements</strong>:",Rt,F,Xe="<li>The first is the <em>agent component</em>, the actor of the scene. We’ll <strong>train the agent by optimizing its policy</strong> (which will tell us what action to take in each state). The policy is called the <em>Brain</em>.</li> <li>Finally, there is the <em>Academy</em>. This component <strong>orchestrates agents and their decision-making processes</strong>. Think of this Academy as a teacher who handles Python API requests.</li>",Ut,B,Ye="To better understand its role, let’s remember the RL process. This can be modeled as a loop that works like this:",It,W,ts='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/RL_process.jpg" alt="The RL process" width="100%"/> <figcaption>The RL Process: a loop of state, action, reward and next state</figcaption> <figcaption>Source: <a href="http://incompleteideas.net/book/RLbook2020.pdf">Reinforcement Learning: An Introduction, Richard Sutton and Andrew G. Barto</a></figcaption>',zt,Z,es="Now, let’s imagine an agent learning to play a platform game. The RL process looks like this:",Nt,b,ss,Gt,u,y,ve,st,fe,Ot,ys='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mn>0</mn></msub></mrow><annotation encoding="application/x-tex">S_0</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',de,nt,ns="Environment",we,xe,_,ye,D,_e,qt,_s='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mn>0</mn></msub></mrow><annotation encoding="application/x-tex">S_0</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',jt,Le,at,Te,Ft,Ls='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mn>0</mn></msub></mrow><annotation encoding="application/x-tex">A_0</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">0</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Me,Ce,L,ke,lt,as="new",Ae,it,be,Bt,Ts='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mn>1</mn></msub></mrow><annotation encoding="application/x-tex">S_1</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">1</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Pe,Ee,T,He,rt,Se,Wt,Ms='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mn>1</mn></msub></mrow><annotation encoding="application/x-tex">R_1</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">1</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',$e,ot,ls="(Positive Reward +1)",Re,Zt,J,is="This RL loop outputs a sequence of <strong>state, action, reward and next state.</strong> The goal of the agent is to <strong>maximize the expected cumulative reward</strong>.",Dt,K,rs="The Academy will be the one that will <strong>send the order to our Agents and ensure that agents are in sync</strong>:",Jt,Q,os="<li>Collect Observations</li> <li>Select your action using your policy</li> <li>Take the Action</li> <li>Reset if you reached the max step or if you’re done.</li>",Kt,P,ps,Qt,V,hs="Now that we understand how ML-Agents works, <strong>we’re ready to train our agents.</strong>",Vt,wt,Xt;return H=new he({}),$=new he({}),z=new he({}),q=new he({}),{c(){v=n("meta"),_t=r(),gt=n("p"),Lt=r(),f=n("h1"),M=n("a"),ut=n("span"),ae(H.$$.fragment),me=r(),X=n("span"),X.textContent=Oe,Tt=r(),S=n("p"),S.innerHTML=qe,Mt=r(),d=n("h2"),C=n("a"),vt=n("span"),ae($.$$.fragment),ce=r(),Y=n("span"),Y.textContent=je,Ct=r(),R=n("p"),R.innerHTML=Fe,kt=r(),U=n("p"),U.innerHTML=Be,At=r(),I=n("figure"),I.innerHTML=We,bt=r(),w=n("h2"),k=n("a"),ft=n("span"),ae(z.$$.fragment),ge=r(),tt=n("span"),tt.textContent=Ze,Pt=r(),N=n("p"),N.textContent=De,Et=r(),G=n("figure"),G.innerHTML=Je,Ht=r(),O=n("ul"),O.innerHTML=Ke,St=r(),x=n("h2"),A=n("a"),dt=n("span"),ae(q.$$.fragment),ue=r(),et=n("span"),et.textContent=Qe,$t=r(),j=n("p"),j.innerHTML=Ve,Rt=r(),F=n("ul"),F.innerHTML=Xe,Ut=r(),B=n("p"),B.textContent=Ye,It=r(),W=n("figure"),W.innerHTML=ts,zt=r(),Z=n("p"),Z.textContent=es,Nt=r(),b=n("img"),Gt=r(),u=n("ul"),y=n("li"),ve=c("Our Agent receives "),st=n("strong"),fe=c("state  "),Ot=new xt(!1),de=c(" from the "),nt=n("strong"),nt.textContent=ns,we=c(" — we receive the first frame of our game (Environment)."),xe=r(),_=n("li"),ye=c("Based on that "),D=n("strong"),_e=c("state "),qt=new xt(!1),jt=c(","),Le=c(" the Agent takes "),at=n("strong"),Te=c("action "),Ft=new xt(!1),Me=c(" — our Agent will move to the right."),Ce=r(),L=n("li"),ke=c("The environment goes to a "),lt=n("strong"),lt.textContent=as,Ae=c(" "),it=n("strong"),be=c("state "),Bt=new xt(!1),Pe=c(" — new frame."),Ee=r(),T=n("li"),He=c("The environment gives some "),rt=n("strong"),Se=c("reward "),Wt=new xt(!1),$e=c(" to the Agent — we’re not dead "),ot=n("em"),ot.textContent=ls,Re=c("."),Zt=r(),J=n("p"),J.innerHTML=is,Dt=r(),K=n("p"),K.innerHTML=rs,Jt=r(),Q=n("ul"),Q.innerHTML=os,Kt=r(),P=n("img"),Qt=r(),V=n("p"),V.innerHTML=hs,Vt=r(),wt=n("p"),this.h()},l(t){const s=Es("svelte-1phssyn",document.head);v=a(s,"META",{name:!0,content:!0}),s.forEach(e),_t=o(t),gt=a(t,"P",{}),p(gt).forEach(e),Lt=o(t),f=a(t,"H1",{class:!0});var Yt=p(f);M=a(Yt,"A",{id:!0,class:!0,href:!0});var ms=p(M);ut=a(ms,"SPAN",{});var cs=p(ut);le(H.$$.fragment,cs),cs.forEach(e),ms.forEach(e),me=o(Yt),X=a(Yt,"SPAN",{"data-svelte-h":!0}),m(X)!=="svelte-hwq2h"&&(X.textContent=Oe),Yt.forEach(e),Tt=o(t),S=a(t,"P",{"data-svelte-h":!0}),m(S)!=="svelte-15uedik"&&(S.innerHTML=qe),Mt=o(t),d=a(t,"H2",{class:!0});var te=p(d);C=a(te,"A",{id:!0,class:!0,href:!0});var gs=p(C);vt=a(gs,"SPAN",{});var us=p(vt);le($.$$.fragment,us),us.forEach(e),gs.forEach(e),ce=o(te),Y=a(te,"SPAN",{"data-svelte-h":!0}),m(Y)!=="svelte-jm9vm1"&&(Y.textContent=je),te.forEach(e),Ct=o(t),R=a(t,"P",{"data-svelte-h":!0}),m(R)!=="svelte-av0s9x"&&(R.innerHTML=Fe),kt=o(t),U=a(t,"P",{"data-svelte-h":!0}),m(U)!=="svelte-fzslkd"&&(U.innerHTML=Be),At=o(t),I=a(t,"FIGURE",{"data-svelte-h":!0}),m(I)!=="svelte-ymq6bm"&&(I.innerHTML=We),bt=o(t),w=a(t,"H2",{class:!0});var ee=p(w);k=a(ee,"A",{id:!0,class:!0,href:!0});var vs=p(k);ft=a(vs,"SPAN",{});var fs=p(ft);le(z.$$.fragment,fs),fs.forEach(e),vs.forEach(e),ge=o(ee),tt=a(ee,"SPAN",{"data-svelte-h":!0}),m(tt)!=="svelte-7bvkgw"&&(tt.textContent=Ze),ee.forEach(e),Pt=o(t),N=a(t,"P",{"data-svelte-h":!0}),m(N)!=="svelte-dq339q"&&(N.textContent=De),Et=o(t),G=a(t,"FIGURE",{"data-svelte-h":!0}),m(G)!=="svelte-10um3w0"&&(G.innerHTML=Je),Ht=o(t),O=a(t,"UL",{"data-svelte-h":!0}),m(O)!=="svelte-2em1lc"&&(O.innerHTML=Ke),St=o(t),x=a(t,"H2",{class:!0});var se=p(x);A=a(se,"A",{id:!0,class:!0,href:!0});var ds=p(A);dt=a(ds,"SPAN",{});var ws=p(dt);le(q.$$.fragment,ws),ws.forEach(e),ds.forEach(e),ue=o(se),et=a(se,"SPAN",{"data-svelte-h":!0}),m(et)!=="svelte-1ntgcet"&&(et.textContent=Qe),se.forEach(e),$t=o(t),j=a(t,"P",{"data-svelte-h":!0}),m(j)!=="svelte-7x17zy"&&(j.innerHTML=Ve),Rt=o(t),F=a(t,"UL",{"data-svelte-h":!0}),m(F)!=="svelte-6e1ah7"&&(F.innerHTML=Xe),Ut=o(t),B=a(t,"P",{"data-svelte-h":!0}),m(B)!=="svelte-1nodyfp"&&(B.textContent=Ye),It=o(t),W=a(t,"FIGURE",{"data-svelte-h":!0}),m(W)!=="svelte-ddctb4"&&(W.innerHTML=ts),zt=o(t),Z=a(t,"P",{"data-svelte-h":!0}),m(Z)!=="svelte-l0svdt"&&(Z.textContent=es),Nt=o(t),b=a(t,"IMG",{src:!0,alt:!0,width:!0}),Gt=o(t),u=a(t,"UL",{});var E=p(u);y=a(E,"LI",{});var pt=p(y);ve=g(pt,"Our Agent receives "),st=a(pt,"STRONG",{});var Ue=p(st);fe=g(Ue,"state  "),Ot=yt(Ue,!1),Ue.forEach(e),de=g(pt," from the "),nt=a(pt,"STRONG",{"data-svelte-h":!0}),m(nt)!=="svelte-17f3im9"&&(nt.textContent=ns),we=g(pt," — we receive the first frame of our game (Environment)."),pt.forEach(e),xe=o(E),_=a(E,"LI",{});var ht=p(_);ye=g(ht,"Based on that "),D=a(ht,"STRONG",{});var ne=p(D);_e=g(ne,"state "),qt=yt(ne,!1),jt=g(ne,","),ne.forEach(e),Le=g(ht," the Agent takes "),at=a(ht,"STRONG",{});var Ie=p(at);Te=g(Ie,"action "),Ft=yt(Ie,!1),Ie.forEach(e),Me=g(ht," — our Agent will move to the right."),ht.forEach(e),Ce=o(E),L=a(E,"LI",{});var mt=p(L);ke=g(mt,"The environment goes to a "),lt=a(mt,"STRONG",{"data-svelte-h":!0}),m(lt)!=="svelte-xvdw54"&&(lt.textContent=as),Ae=g(mt," "),it=a(mt,"STRONG",{});var ze=p(it);be=g(ze,"state "),Bt=yt(ze,!1),ze.forEach(e),Pe=g(mt," — new frame."),mt.forEach(e),Ee=o(E),T=a(E,"LI",{});var ct=p(T);He=g(ct,"The environment gives some "),rt=a(ct,"STRONG",{});var Ne=p(rt);Se=g(Ne,"reward "),Wt=yt(Ne,!1),Ne.forEach(e),$e=g(ct," to the Agent — we’re not dead "),ot=a(ct,"EM",{"data-svelte-h":!0}),m(ot)!=="svelte-wepaxr"&&(ot.textContent=ls),Re=g(ct,"."),ct.forEach(e),E.forEach(e),Zt=o(t),J=a(t,"P",{"data-svelte-h":!0}),m(J)!=="svelte-3iun6t"&&(J.innerHTML=is),Dt=o(t),K=a(t,"P",{"data-svelte-h":!0}),m(K)!=="svelte-1q61jnh"&&(K.innerHTML=rs),Jt=o(t),Q=a(t,"UL",{"data-svelte-h":!0}),m(Q)!=="svelte-w2l7uo"&&(Q.innerHTML=os),Kt=o(t),P=a(t,"IMG",{src:!0,alt:!0,width:!0}),Qt=o(t),V=a(t,"P",{"data-svelte-h":!0}),m(V)!=="svelte-1j4rf70"&&(V.innerHTML=hs),Vt=o(t),wt=a(t,"P",{}),p(wt).forEach(e),this.h()},h(){h(v,"name","hf:doc:metadata"),h(v,"content",JSON.stringify(Ss)),h(M,"id","how-mlagents-works"),h(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(M,"href","#how-mlagents-works"),h(f,"class","relative group"),h(C,"id","what-is-mlagents"),h(C,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(C,"href","#what-is-mlagents"),h(d,"class","relative group"),h(k,"id","six-components"),h(k,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(k,"href","#six-components"),h(w,"class","relative group"),h(A,"id","inside-learning-component"),h(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(A,"href","#inside-learning-component"),h(x,"class","relative group"),xs(b.src,ss="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit1/RL_process_game.jpg")||h(b,"src",ss),h(b,"alt","The RL process"),h(b,"width","100%"),Ot.a=null,qt.a=jt,Ft.a=null,Bt.a=null,Wt.a=null,xs(P.src,ps="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/academy.png")||h(P,"src",ps),h(P,"alt","The MLAgents Academy"),h(P,"width","100%")},m(t,s){l(document.head,v),i(t,_t,s),i(t,gt,s),i(t,Lt,s),i(t,f,s),l(f,M),l(M,ut),ie(H,ut,null),l(f,me),l(f,X),i(t,Tt,s),i(t,S,s),i(t,Mt,s),i(t,d,s),l(d,C),l(C,vt),ie($,vt,null),l(d,ce),l(d,Y),i(t,Ct,s),i(t,R,s),i(t,kt,s),i(t,U,s),i(t,At,s),i(t,I,s),i(t,bt,s),i(t,w,s),l(w,k),l(k,ft),ie(z,ft,null),l(w,ge),l(w,tt),i(t,Pt,s),i(t,N,s),i(t,Et,s),i(t,G,s),i(t,Ht,s),i(t,O,s),i(t,St,s),i(t,x,s),l(x,A),l(A,dt),ie(q,dt,null),l(x,ue),l(x,et),i(t,$t,s),i(t,j,s),i(t,Rt,s),i(t,F,s),i(t,Ut,s),i(t,B,s),i(t,It,s),i(t,W,s),i(t,zt,s),i(t,Z,s),i(t,Nt,s),i(t,b,s),i(t,Gt,s),i(t,u,s),l(u,y),l(y,ve),l(y,st),l(st,fe),Ot.m(ys,st),l(y,de),l(y,nt),l(y,we),l(u,xe),l(u,_),l(_,ye),l(_,D),l(D,_e),qt.m(_s,D),l(D,jt),l(_,Le),l(_,at),l(at,Te),Ft.m(Ls,at),l(_,Me),l(u,Ce),l(u,L),l(L,ke),l(L,lt),l(L,Ae),l(L,it),l(it,be),Bt.m(Ts,it),l(L,Pe),l(u,Ee),l(u,T),l(T,He),l(T,rt),l(rt,Se),Wt.m(Ms,rt),l(T,$e),l(T,ot),l(T,Re),i(t,Zt,s),i(t,J,s),i(t,Dt,s),i(t,K,s),i(t,Jt,s),i(t,Q,s),i(t,Kt,s),i(t,P,s),i(t,Qt,s),i(t,V,s),i(t,Vt,s),i(t,wt,s),Xt=!0},p:ks,i(t){Xt||(re(H.$$.fragment,t),re($.$$.fragment,t),re(z.$$.fragment,t),re(q.$$.fragment,t),Xt=!0)},o(t){oe(H.$$.fragment,t),oe($.$$.fragment,t),oe(z.$$.fragment,t),oe(q.$$.fragment,t),Xt=!1},d(t){t&&(e(_t),e(gt),e(Lt),e(f),e(Tt),e(S),e(Mt),e(d),e(Ct),e(R),e(kt),e(U),e(At),e(I),e(bt),e(w),e(Pt),e(N),e(Et),e(G),e(Ht),e(O),e(St),e(x),e($t),e(j),e(Rt),e(F),e(Ut),e(B),e(It),e(W),e(zt),e(Z),e(Nt),e(b),e(Gt),e(u),e(Zt),e(J),e(Dt),e(K),e(Jt),e(Q),e(Kt),e(P),e(Qt),e(V),e(Vt),e(wt)),e(v),pe(H),pe($),pe(z),pe(q)}}}const Ss={local:"how-mlagents-works",sections:[{local:"what-is-mlagents",title:"What is Unity ML-Agents? "},{local:"six-components",title:"The six components "},{local:"inside-learning-component",title:"Inside the Learning Component "}],title:"How do Unity ML-Agents work? "};function $s(Ge){return As(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class zs extends bs{constructor(v){super(),Ps(this,v,$s,Hs,Cs,{})}}export{zs as component};
