import{s as an,f as R,n as en,o as nn}from"../chunks/scheduler.37c15a92.js";import{S as ln,i as pn,g as e,s as p,u as ca,m as h,H as u,A as mn,h as n,f as s,c as m,j as r,v as ha,y as c,n as g,B as v,k as o,o as a,a as i,w as ga,d as ua,t as va,x as da}from"../chunks/index.b01106c0.js";import{I as fa}from"../chunks/IconCopyLink.77b762b4.js";function rn(Ua){let x,Dt,Gt,Jt,y,E,jt,O,wa,ut,Qa="Advantage Actor-Critic (A2C)",Kt,_,P,Rt,U,xa,vt,Fa="Reducing variance with Actor-Critic methods",Xt,Q,Va="The solution to reducing the variance of the Reinforce algorithm and training our agent faster and better is to use a combination of Policy-Based and Value-Based methods: <em>the Actor-Critic method</em>.",Zt,F,Ba="To understand the Actor-Critic, imagine you’re playing a video game. You can play with a friend that will provide you with some feedback. You’re the Actor and your friend is the Critic.",ts,V,Wa,ss,B,Ya="You don’t know how to play at the beginning, <strong>so you try some actions randomly</strong>. The Critic observes your action and <strong>provides feedback</strong>.",as,W,Da="Learning from this feedback, <strong>you’ll update your policy and be better at playing that game.</strong>",es,Y,Ja="On the other hand, your friend (Critic) will also update their way to provide feedback so it can be better next time.",ns,D,Ka="This is the idea behind Actor-Critic. We learn two function approximations:",ls,S,Ot,C,dt,Xa="A policy",ya,ft,Za="controls how our agent acts",_a,is,Oe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>π</mi><mi>θ</mi></msub><mo stretchy="false">(</mo><mi>s</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\pi_{\\theta}(s) </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">π</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mclose">)</span></span></span></span>',Ca,Ut,J,wt,te="A value function",ba,ps,Ue='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mover accent="true"><mi>q</mi><mo>^</mo></mover><mi>w</mi></msub><mo stretchy="false">(</mo><mi>s</mi><mo separator="true">,</mo><mi>a</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\hat{q}_{w}(s,a) </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord accent"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.6944em;"><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">q</span></span><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="accent-body" style="left:-0.1667em;"><span class="mord">^</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.1944em;"><span></span></span></span></span></span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.1514em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.02691em;">w</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal">a</span><span class="mclose">)</span></span></span></span>',ms,b,$,Qt,K,ka,xt,se="The Actor-Critic Process",rs,X,ae="As we saw, with Actor-Critic methods, there are two function approximations (two neural networks):",os,I,k,yt,ee="Actor",Aa,_t,ne="policy function",Ma,cs,Qe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>π</mi><mi>θ</mi></msub><mo stretchy="false">(</mo><mi>s</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\pi_{\\theta}(s) </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.03588em;">π</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.02778em;">θ</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mclose">)</span></span></span></span>',La,A,Ct,le="Critic",za,bt,ie="value function",Ta,hs,Fe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mover accent="true"><mi>q</mi><mo>^</mo></mover><mi>w</mi></msub><mo stretchy="false">(</mo><mi>s</mi><mo separator="true">,</mo><mi>a</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> \\hat{q}_{w}(s,a) </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord accent"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.6944em;"><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="mord mathnormal" style="margin-right:0.03588em;">q</span></span><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="accent-body" style="left:-0.1667em;"><span class="mord">^</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.1944em;"><span></span></span></span></span></span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.1514em;"><span style="top:-2.55em;margin-left:-0.0359em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.02691em;">w</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal">a</span><span class="mclose">)</span></span></span></span>',gs,Z,pe="Let’s see the training process to understand how the Actor and Critic are optimized:",us,H,Ft,M,Ea,vs,Ve='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> S_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ds,kt,me="pass it as input through our Actor and Critic",Pa,Sa,Vt,L,$a,At,re="outputs an action",Ia,fs,Be='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> A_t </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ws,xs,tt,oe,ys,Mt,d,Ha,_s,We='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> S_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Cs,bs,Ye='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> A_t </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ks,Lt,ce="computes the value of taking that action at that state: the Q-value",qa,As,st,he,Ms,zt,f,Na,Ls,De='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> A_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',zs,Ts,Je='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex"> S_{t+1}</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Es,Ps,Ke='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex"> R_{t+1} </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Ss,$s,at,ge,Is,et,ue="<li>The Actor updates its policy parameters using the Q value.</li>",Hs,nt,ve,qs,q,Bt,z,Ga,Ns,Xe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>A</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex"> A_{t+1} </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Gs,js,Ze='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>S</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub></mrow><annotation encoding="application/x-tex"> S_{t+1} </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span></span></span></span>',Rs,ja,Tt,de="<p>The Critic then updates its value parameters.</p>",Os,lt,fe,Us,T,N,Wt,it,Ra,Et,we="Adding Advantage in Actor-Critic (A2C)",Qs,pt,xe="The idea is that the Advantage function calculates the relative advantage of an action compared to the others possible at a state: <strong>how taking that action at a state is better compared to the average value of the state</strong>. It’s subtracting the mean value of the state from the state action pair:",Fs,mt,ye,Vs,rt,_e="In other words, this function calculates <strong>the extra reward we get if we take this action at that state compared to the mean reward we get at that state</strong>.",Bs,ot,Ce="The extra reward is what’s beyond the expected value of that state.",Ws,ct,be="<li>If A(s,a) &gt; 0: our gradient is <strong>pushed in that direction</strong>.</li> <li>If A(s,a) &lt; 0 (our action does worse than the average value of that state), <strong>our gradient is pushed in the opposite direction</strong>.</li>",Ys,w,Oa,Ds,tn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>Q</mi><mo stretchy="false">(</mo><mi>s</mi><mo separator="true">,</mo><mi>a</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> Q(s,a)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">Q</span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord mathnormal">a</span><span class="mclose">)</span></span></span></span>',Js,Ks,sn='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>V</mi><mo stretchy="false">(</mo><mi>s</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> V(s)</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal" style="margin-right:0.22222em;">V</span><span class="mopen">(</span><span class="mord mathnormal">s</span><span class="mclose">)</span></span></span></span>',Xs,Pt,ke="we can use the TD error as a good estimator of the advantage function.",Zs,ht,Ae,ta,Yt,sa;return O=new fa({}),U=new fa({}),K=new fa({}),it=new fa({}),{c(){x=e("meta"),Dt=p(),Gt=e("p"),Jt=p(),y=e("h1"),E=e("a"),jt=e("span"),ca(O.$$.fragment),wa=p(),ut=e("span"),ut.textContent=Qa,Kt=p(),_=e("h2"),P=e("a"),Rt=e("span"),ca(U.$$.fragment),xa=p(),vt=e("span"),vt.textContent=Fa,Xt=p(),Q=e("p"),Q.innerHTML=Va,Zt=p(),F=e("p"),F.textContent=Ba,ts=p(),V=e("img"),ss=p(),B=e("p"),B.innerHTML=Ya,as=p(),W=e("p"),W.innerHTML=Da,es=p(),Y=e("p"),Y.textContent=Ja,ns=p(),D=e("p"),D.textContent=Ka,ls=p(),S=e("ul"),Ot=e("li"),C=e("p"),dt=e("em"),dt.textContent=Xa,ya=h(" that "),ft=e("strong"),ft.textContent=Za,_a=h(": "),is=new u(!1),Ca=p(),Ut=e("li"),J=e("p"),wt=e("em"),wt.textContent=te,ba=h(" to assist the policy update by measuring how good the action taken is: "),ps=new u(!1),ms=p(),b=e("h2"),$=e("a"),Qt=e("span"),ca(K.$$.fragment),ka=p(),xt=e("span"),xt.textContent=se,rs=h(`


Now that we have seen the Actor Critic's big picture, let's dive deeper to understand how the Actor and Critic improve together during the training.
`),X=e("p"),X.textContent=ae,os=p(),I=e("ul"),k=e("li"),yt=e("em"),yt.textContent=ee,Aa=h(", a "),_t=e("strong"),_t.textContent=ne,Ma=h(" parameterized by theta: "),cs=new u(!1),La=p(),A=e("li"),Ct=e("em"),Ct.textContent=le,za=h(", a "),bt=e("strong"),bt.textContent=ie,Ta=h(" parameterized by w: "),hs=new u(!1),gs=p(),Z=e("p"),Z.textContent=pe,us=p(),H=e("ul"),Ft=e("li"),M=e("p"),Ea=h("At each timestep, t, we get the current state "),vs=new u(!1),ds=h(" from the environment and "),kt=e("strong"),kt.textContent=me,Pa=h("."),Sa=p(),Vt=e("li"),L=e("p"),$a=h("Our Policy takes the state and "),At=e("strong"),At.textContent=re,Ia=p(),fs=new u(!1),ws=h("."),xs=p(),tt=e("img"),ys=p(),Mt=e("ul"),d=e("li"),Ha=h("The Critic takes that action also as input and, using "),_s=new u(!1),Cs=h(" and "),bs=new u(!1),ks=h(", "),Lt=e("strong"),Lt.textContent=ce,qa=h("."),As=p(),st=e("img"),Ms=p(),zt=e("ul"),f=e("li"),Na=h("The action "),Ls=new u(!1),zs=h(" performed in the environment outputs a new state "),Ts=new u(!1),Es=h(" and a reward "),Ps=new u(!1),Ss=h(" ."),$s=p(),at=e("img"),Is=p(),et=e("ul"),et.innerHTML=ue,Hs=p(),nt=e("img"),qs=p(),q=e("ul"),Bt=e("li"),z=e("p"),Ga=h("Thanks to its updated parameters, the Actor produces the next action to take at "),Ns=new u(!1),Gs=h(" given the new state "),js=new u(!1),Rs=h("."),ja=p(),Tt=e("li"),Tt.innerHTML=de,Os=p(),lt=e("img"),Us=p(),T=e("h2"),N=e("a"),Wt=e("span"),ca(it.$$.fragment),Ra=p(),Et=e("span"),Et.textContent=we,Qs=h(`


We can stabilize learning further by **using the Advantage function as Critic instead of the Action value function**.
`),pt=e("p"),pt.innerHTML=xe,Fs=p(),mt=e("img"),Vs=p(),rt=e("p"),rt.innerHTML=_e,Bs=p(),ot=e("p"),ot.textContent=Ce,Ws=p(),ct=e("ul"),ct.innerHTML=be,Ys=p(),w=e("p"),Oa=h("The problem with implementing this advantage function is that it requires two value functions —  "),Ds=new u(!1),Js=h(" and  "),Ks=new u(!1),Xs=h(". Fortunately, "),Pt=e("strong"),Pt.textContent=ke,Zs=p(),ht=e("img"),ta=p(),Yt=e("p"),this.h()},l(t){const l=mn("svelte-1phssyn",document.head);x=n(l,"META",{name:!0,content:!0}),l.forEach(s),Dt=m(t),Gt=n(t,"P",{}),r(Gt).forEach(s),Jt=m(t),y=n(t,"H1",{class:!0});var aa=r(y);E=n(aa,"A",{id:!0,class:!0,href:!0});var Me=r(E);jt=n(Me,"SPAN",{});var Le=r(jt);ha(O.$$.fragment,Le),Le.forEach(s),Me.forEach(s),wa=m(aa),ut=n(aa,"SPAN",{"data-svelte-h":!0}),c(ut)!=="svelte-17vzifz"&&(ut.textContent=Qa),aa.forEach(s),Kt=m(t),_=n(t,"H2",{class:!0});var ea=r(_);P=n(ea,"A",{id:!0,class:!0,href:!0});var ze=r(P);Rt=n(ze,"SPAN",{});var Te=r(Rt);ha(U.$$.fragment,Te),Te.forEach(s),ze.forEach(s),xa=m(ea),vt=n(ea,"SPAN",{"data-svelte-h":!0}),c(vt)!=="svelte-p18bx5"&&(vt.textContent=Fa),ea.forEach(s),Xt=m(t),Q=n(t,"P",{"data-svelte-h":!0}),c(Q)!=="svelte-krwho4"&&(Q.innerHTML=Va),Zt=m(t),F=n(t,"P",{"data-svelte-h":!0}),c(F)!=="svelte-hd3rkl"&&(F.textContent=Ba),ts=m(t),V=n(t,"IMG",{src:!0,alt:!0}),ss=m(t),B=n(t,"P",{"data-svelte-h":!0}),c(B)!=="svelte-1lbzw5w"&&(B.innerHTML=Ya),as=m(t),W=n(t,"P",{"data-svelte-h":!0}),c(W)!=="svelte-1g68qqi"&&(W.innerHTML=Da),es=m(t),Y=n(t,"P",{"data-svelte-h":!0}),c(Y)!=="svelte-1i1ihbx"&&(Y.textContent=Ja),ns=m(t),D=n(t,"P",{"data-svelte-h":!0}),c(D)!=="svelte-1fcp10q"&&(D.textContent=Ka),ls=m(t),S=n(t,"UL",{});var na=r(S);Ot=n(na,"LI",{});var Ee=r(Ot);C=n(Ee,"P",{});var St=r(C);dt=n(St,"EM",{"data-svelte-h":!0}),c(dt)!=="svelte-1q5uc95"&&(dt.textContent=Xa),ya=g(St," that "),ft=n(St,"STRONG",{"data-svelte-h":!0}),c(ft)!=="svelte-9j9b6"&&(ft.textContent=Za),_a=g(St,": "),is=v(St,!1),St.forEach(s),Ee.forEach(s),Ca=m(na),Ut=n(na,"LI",{});var Pe=r(Ut);J=n(Pe,"P",{});var la=r(J);wt=n(la,"EM",{"data-svelte-h":!0}),c(wt)!=="svelte-1lxl85o"&&(wt.textContent=te),ba=g(la," to assist the policy update by measuring how good the action taken is: "),ps=v(la,!1),la.forEach(s),Pe.forEach(s),na.forEach(s),ms=m(t),b=n(t,"H2",{class:!0});var ia=r(b);$=n(ia,"A",{id:!0,class:!0,href:!0});var Se=r($);Qt=n(Se,"SPAN",{});var $e=r(Qt);ha(K.$$.fragment,$e),$e.forEach(s),Se.forEach(s),ka=m(ia),xt=n(ia,"SPAN",{"data-svelte-h":!0}),c(xt)!=="svelte-a8x549"&&(xt.textContent=se),ia.forEach(s),rs=g(t,`


Now that we have seen the Actor Critic's big picture, let's dive deeper to understand how the Actor and Critic improve together during the training.
`),X=n(t,"P",{"data-svelte-h":!0}),c(X)!=="svelte-eu7748"&&(X.textContent=ae),os=m(t),I=n(t,"UL",{});var pa=r(I);k=n(pa,"LI",{});var $t=r(k);yt=n($t,"EM",{"data-svelte-h":!0}),c(yt)!=="svelte-1df5trl"&&(yt.textContent=ee),Aa=g($t,", a "),_t=n($t,"STRONG",{"data-svelte-h":!0}),c(_t)!=="svelte-m02j94"&&(_t.textContent=ne),Ma=g($t," parameterized by theta: "),cs=v($t,!1),$t.forEach(s),La=m(pa),A=n(pa,"LI",{});var It=r(A);Ct=n(It,"EM",{"data-svelte-h":!0}),c(Ct)!=="svelte-18wqahq"&&(Ct.textContent=le),za=g(It,", a "),bt=n(It,"STRONG",{"data-svelte-h":!0}),c(bt)!=="svelte-1fbqdkf"&&(bt.textContent=ie),Ta=g(It," parameterized by w: "),hs=v(It,!1),It.forEach(s),pa.forEach(s),gs=m(t),Z=n(t,"P",{"data-svelte-h":!0}),c(Z)!=="svelte-qos3jx"&&(Z.textContent=pe),us=m(t),H=n(t,"UL",{});var ma=r(H);Ft=n(ma,"LI",{});var Ie=r(Ft);M=n(Ie,"P",{});var Ht=r(M);Ea=g(Ht,"At each timestep, t, we get the current state "),vs=v(Ht,!1),ds=g(Ht," from the environment and "),kt=n(Ht,"STRONG",{"data-svelte-h":!0}),c(kt)!=="svelte-7r20hj"&&(kt.textContent=me),Pa=g(Ht,"."),Ht.forEach(s),Ie.forEach(s),Sa=m(ma),Vt=n(ma,"LI",{});var He=r(Vt);L=n(He,"P",{});var qt=r(L);$a=g(qt,"Our Policy takes the state and "),At=n(qt,"STRONG",{"data-svelte-h":!0}),c(At)!=="svelte-10nn435"&&(At.textContent=re),Ia=m(qt),fs=v(qt,!1),ws=g(qt,"."),qt.forEach(s),He.forEach(s),ma.forEach(s),xs=m(t),tt=n(t,"IMG",{src:!0,alt:!0}),ys=m(t),Mt=n(t,"UL",{});var qe=r(Mt);d=n(qe,"LI",{});var G=r(d);Ha=g(G,"The Critic takes that action also as input and, using "),_s=v(G,!1),Cs=g(G," and "),bs=v(G,!1),ks=g(G,", "),Lt=n(G,"STRONG",{"data-svelte-h":!0}),c(Lt)!=="svelte-uggext"&&(Lt.textContent=ce),qa=g(G,"."),G.forEach(s),qe.forEach(s),As=m(t),st=n(t,"IMG",{src:!0,alt:!0}),Ms=m(t),zt=n(t,"UL",{});var Ne=r(zt);f=n(Ne,"LI",{});var j=r(f);Na=g(j,"The action "),Ls=v(j,!1),zs=g(j," performed in the environment outputs a new state "),Ts=v(j,!1),Es=g(j," and a reward "),Ps=v(j,!1),Ss=g(j," ."),j.forEach(s),Ne.forEach(s),$s=m(t),at=n(t,"IMG",{src:!0,alt:!0}),Is=m(t),et=n(t,"UL",{"data-svelte-h":!0}),c(et)!=="svelte-1xd4i4c"&&(et.innerHTML=ue),Hs=m(t),nt=n(t,"IMG",{src:!0,alt:!0}),qs=m(t),q=n(t,"UL",{});var ra=r(q);Bt=n(ra,"LI",{});var Ge=r(Bt);z=n(Ge,"P",{});var Nt=r(z);Ga=g(Nt,"Thanks to its updated parameters, the Actor produces the next action to take at "),Ns=v(Nt,!1),Gs=g(Nt," given the new state "),js=v(Nt,!1),Rs=g(Nt,"."),Nt.forEach(s),Ge.forEach(s),ja=m(ra),Tt=n(ra,"LI",{"data-svelte-h":!0}),c(Tt)!=="svelte-orop3a"&&(Tt.innerHTML=de),ra.forEach(s),Os=m(t),lt=n(t,"IMG",{src:!0,alt:!0}),Us=m(t),T=n(t,"H2",{class:!0});var oa=r(T);N=n(oa,"A",{id:!0,class:!0,href:!0});var je=r(N);Wt=n(je,"SPAN",{});var Re=r(Wt);ha(it.$$.fragment,Re),Re.forEach(s),je.forEach(s),Ra=m(oa),Et=n(oa,"SPAN",{"data-svelte-h":!0}),c(Et)!=="svelte-1lrgaaz"&&(Et.textContent=we),oa.forEach(s),Qs=g(t,`


We can stabilize learning further by **using the Advantage function as Critic instead of the Action value function**.
`),pt=n(t,"P",{"data-svelte-h":!0}),c(pt)!=="svelte-1ihnygk"&&(pt.innerHTML=xe),Fs=m(t),mt=n(t,"IMG",{src:!0,alt:!0}),Vs=m(t),rt=n(t,"P",{"data-svelte-h":!0}),c(rt)!=="svelte-1y9z9x3"&&(rt.innerHTML=_e),Bs=m(t),ot=n(t,"P",{"data-svelte-h":!0}),c(ot)!=="svelte-102uivm"&&(ot.textContent=Ce),Ws=m(t),ct=n(t,"UL",{"data-svelte-h":!0}),c(ct)!=="svelte-9js17k"&&(ct.innerHTML=be),Ys=m(t),w=n(t,"P",{});var gt=r(w);Oa=g(gt,"The problem with implementing this advantage function is that it requires two value functions —  "),Ds=v(gt,!1),Js=g(gt," and  "),Ks=v(gt,!1),Xs=g(gt,". Fortunately, "),Pt=n(gt,"STRONG",{"data-svelte-h":!0}),c(Pt)!=="svelte-a0qaqz"&&(Pt.textContent=ke),gt.forEach(s),Zs=m(t),ht=n(t,"IMG",{src:!0,alt:!0}),ta=m(t),Yt=n(t,"P",{}),r(Yt).forEach(s),this.h()},h(){o(x,"name","hf:doc:metadata"),o(x,"content",JSON.stringify(on)),o(E,"id","advantage-actor-critic"),o(E,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(E,"href","#advantage-actor-critic"),o(y,"class","relative group"),o(P,"id","reducing-variance-with-actorcritic-methods"),o(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(P,"href","#reducing-variance-with-actorcritic-methods"),o(_,"class","relative group"),R(V.src,Wa="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/ac.jpg")||o(V,"src",Wa),o(V,"alt","Actor Critic"),is.a=null,ps.a=null,o($,"id","the-actorcritic-process"),o($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o($,"href","#the-actorcritic-process"),o(b,"class","relative group"),cs.a=null,hs.a=null,vs.a=ds,fs.a=ws,R(tt.src,oe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/step1.jpg")||o(tt,"src",oe),o(tt,"alt","Step 1 Actor Critic"),_s.a=Cs,bs.a=ks,R(st.src,he="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/step2.jpg")||o(st,"src",he),o(st,"alt","Step 2 Actor Critic"),Ls.a=zs,Ts.a=Es,Ps.a=Ss,R(at.src,ge="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/step3.jpg")||o(at,"src",ge),o(at,"alt","Step 3 Actor Critic"),R(nt.src,ve="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/step4.jpg")||o(nt,"src",ve),o(nt,"alt","Step 4 Actor Critic"),Ns.a=Gs,js.a=Rs,R(lt.src,fe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/step5.jpg")||o(lt,"src",fe),o(lt,"alt","Step 5 Actor Critic"),o(N,"id","adding-advantage-in-actorcritic-a2c"),o(N,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),o(N,"href","#adding-advantage-in-actorcritic-a2c"),o(T,"class","relative group"),R(mt.src,ye="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/advantage1.jpg")||o(mt,"src",ye),o(mt,"alt","Advantage Function"),Ds.a=Js,Ks.a=Xs,R(ht.src,Ae="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit8/advantage2.jpg")||o(ht,"src",Ae),o(ht,"alt","Advantage Function")},m(t,l){a(document.head,x),i(t,Dt,l),i(t,Gt,l),i(t,Jt,l),i(t,y,l),a(y,E),a(E,jt),ga(O,jt,null),a(y,wa),a(y,ut),i(t,Kt,l),i(t,_,l),a(_,P),a(P,Rt),ga(U,Rt,null),a(_,xa),a(_,vt),i(t,Xt,l),i(t,Q,l),i(t,Zt,l),i(t,F,l),i(t,ts,l),i(t,V,l),i(t,ss,l),i(t,B,l),i(t,as,l),i(t,W,l),i(t,es,l),i(t,Y,l),i(t,ns,l),i(t,D,l),i(t,ls,l),i(t,S,l),a(S,Ot),a(Ot,C),a(C,dt),a(C,ya),a(C,ft),a(C,_a),is.m(Oe,C),a(S,Ca),a(S,Ut),a(Ut,J),a(J,wt),a(J,ba),ps.m(Ue,J),i(t,ms,l),i(t,b,l),a(b,$),a($,Qt),ga(K,Qt,null),a(b,ka),a(b,xt),i(t,rs,l),i(t,X,l),i(t,os,l),i(t,I,l),a(I,k),a(k,yt),a(k,Aa),a(k,_t),a(k,Ma),cs.m(Qe,k),a(I,La),a(I,A),a(A,Ct),a(A,za),a(A,bt),a(A,Ta),hs.m(Fe,A),i(t,gs,l),i(t,Z,l),i(t,us,l),i(t,H,l),a(H,Ft),a(Ft,M),a(M,Ea),vs.m(Ve,M),a(M,ds),a(M,kt),a(M,Pa),a(H,Sa),a(H,Vt),a(Vt,L),a(L,$a),a(L,At),a(L,Ia),fs.m(Be,L),a(L,ws),i(t,xs,l),i(t,tt,l),i(t,ys,l),i(t,Mt,l),a(Mt,d),a(d,Ha),_s.m(We,d),a(d,Cs),bs.m(Ye,d),a(d,ks),a(d,Lt),a(d,qa),i(t,As,l),i(t,st,l),i(t,Ms,l),i(t,zt,l),a(zt,f),a(f,Na),Ls.m(De,f),a(f,zs),Ts.m(Je,f),a(f,Es),Ps.m(Ke,f),a(f,Ss),i(t,$s,l),i(t,at,l),i(t,Is,l),i(t,et,l),i(t,Hs,l),i(t,nt,l),i(t,qs,l),i(t,q,l),a(q,Bt),a(Bt,z),a(z,Ga),Ns.m(Xe,z),a(z,Gs),js.m(Ze,z),a(z,Rs),a(q,ja),a(q,Tt),i(t,Os,l),i(t,lt,l),i(t,Us,l),i(t,T,l),a(T,N),a(N,Wt),ga(it,Wt,null),a(T,Ra),a(T,Et),i(t,Qs,l),i(t,pt,l),i(t,Fs,l),i(t,mt,l),i(t,Vs,l),i(t,rt,l),i(t,Bs,l),i(t,ot,l),i(t,Ws,l),i(t,ct,l),i(t,Ys,l),i(t,w,l),a(w,Oa),Ds.m(tn,w),a(w,Js),Ks.m(sn,w),a(w,Xs),a(w,Pt),i(t,Zs,l),i(t,ht,l),i(t,ta,l),i(t,Yt,l),sa=!0},p:en,i(t){sa||(ua(O.$$.fragment,t),ua(U.$$.fragment,t),ua(K.$$.fragment,t),ua(it.$$.fragment,t),sa=!0)},o(t){va(O.$$.fragment,t),va(U.$$.fragment,t),va(K.$$.fragment,t),va(it.$$.fragment,t),sa=!1},d(t){t&&(s(Dt),s(Gt),s(Jt),s(y),s(Kt),s(_),s(Xt),s(Q),s(Zt),s(F),s(ts),s(V),s(ss),s(B),s(as),s(W),s(es),s(Y),s(ns),s(D),s(ls),s(S),s(ms),s(b),s(rs),s(X),s(os),s(I),s(gs),s(Z),s(us),s(H),s(xs),s(tt),s(ys),s(Mt),s(As),s(st),s(Ms),s(zt),s($s),s(at),s(Is),s(et),s(Hs),s(nt),s(qs),s(q),s(Os),s(lt),s(Us),s(T),s(Qs),s(pt),s(Fs),s(mt),s(Vs),s(rt),s(Bs),s(ot),s(Ws),s(ct),s(Ys),s(w),s(Zs),s(ht),s(ta),s(Yt)),s(x),da(O),da(U),da(K),da(it)}}}const on={local:"advantage-actor-critic",sections:[{local:"reducing-variance-with-actorcritic-methods",title:"Reducing variance with Actor-Critic methods"},{local:"the-actorcritic-process",title:"The Actor-Critic Process"},{local:"adding-advantage-in-actorcritic-a2c",title:"Adding Advantage in Actor-Critic (A2C)"}],title:"Advantage Actor-Critic (A2C) "};function cn(Ua){return nn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class vn extends ln{constructor(x){super(),pn(this,x,cn,rn,an,{})}}export{vn as component};
