import{s as nt,f as it,n as at,o as st}from"../chunks/scheduler.37c15a92.js";import{S as rt,i as ot,g as a,s as r,u as Le,A as lt,h as s,f as t,c as o,j as g,v as Me,y as l,k as u,o as m,a as i,w as Te,d as He,t as be,x as Ce}from"../chunks/index.b01106c0.js";import{I as ke}from"../chunks/IconCopyLink.77b762b4.js";function ut($e){let p,J,z,K,h,v,W,y,ye,N,Pe="An introduction to Multi-Agents Reinforcement Learning (MARL)",Q,f,d,D,_,_e,j,Ae="From single agent to multiple agents",V,x,Ee="In the first unit, we learned to train agents in a single-agent system. When our agent was alone in its environment: <strong>it was not cooperating or collaborating with other agents</strong>.",X,L,Se='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/patchwork.jpg" alt="Patchwork"/> <figcaption>A patchwork of all the environments you&#39;ve trained your agents on since the beginning of the course</figcaption>',Y,M,Fe="When we do multi-agents reinforcement learning (MARL), we are in a situation where we have multiple agents <strong>that share and interact in a common environment</strong>.",Z,T,Ie="For instance, you can think of a warehouse where <strong>multiple robots need to navigate to load and unload packages</strong>.",ee,H,Re='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/warehouse.jpg" alt="Warehouse"/> <figcaption>[Image by upklyak](https://www.freepik.com/free-vector/robots-warehouse-interior-automated-machines_32117680.htm#query=warehouse robot&amp;position=17&amp;from_view=keyword) on Freepik</figcaption>',te,b,Ue="Or a road with <strong>several autonomous vehicles</strong>.",ne,C,qe='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/selfdrivingcar.jpg" alt="Self driving cars"/> <figcaption>[Image by jcomp](https://www.freepik.com/free-vector/autonomous-smart-car-automatic-wireless-sensor-driving-road-around-car-autonomous-smart-car-goes-scans-roads-observe-distance-automatic-braking-system_26413332.htm#query=self driving cars highway&amp;position=34&amp;from_view=search&amp;track=ais) on Freepik</figcaption>',ie,k,Ne="In these examples, we have <strong>multiple agents interacting in the environment and with the other agents</strong>. This implies defining a multi-agents system. But first, let’s understand the different types of multi-agent environments.",ae,c,w,O,$,xe,G,je="Different types of multi-agent environments",se,P,Ge="Given that, in a multi-agent system, agents interact with other agents, we can have different types of environments:",re,A,ze="<li><em>Cooperative environments</em>: where your agents need <strong>to maximize the common benefits</strong>.</li>",oe,E,We="For instance, in a warehouse, <strong>robots must collaborate to load and unload the packages efficiently (as fast as possible)</strong>.",le,S,De="<li><em>Competitive/Adversarial environments</em>: in this case, your agent <strong>wants to maximize its benefits by minimizing the opponent’s</strong>.</li>",ue,F,Oe="For example, in a game of tennis, <strong>each agent wants to beat the other agent</strong>.",me,I,Be,ge,R,Je="<li><em>Mixed of both adversarial and cooperative</em>: like in our SoccerTwos environment, two agents are part of a team (blue or purple): they need to cooperate with each other and beat the opponent team.</li>",pe,U,Ke='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/soccertwos.gif" alt="SoccerTwos"/> <figcaption>This environment was made by the <a href="https://github.com/Unity-Technologies/ml-agents">Unity MLAgents Team</a></figcaption>',he,q,Qe="So now we might wonder: how can we design these multi-agent systems? Said differently, <strong>how can we train agents in a multi-agent setting</strong> ?",fe,B,ce;return y=new ke({}),_=new ke({}),$=new ke({}),{c(){p=a("meta"),J=r(),z=a("p"),K=r(),h=a("h1"),v=a("a"),W=a("span"),Le(y.$$.fragment),ye=r(),N=a("span"),N.textContent=Pe,Q=r(),f=a("h2"),d=a("a"),D=a("span"),Le(_.$$.fragment),_e=r(),j=a("span"),j.textContent=Ae,V=r(),x=a("p"),x.innerHTML=Ee,X=r(),L=a("figure"),L.innerHTML=Se,Y=r(),M=a("p"),M.innerHTML=Fe,Z=r(),T=a("p"),T.innerHTML=Ie,ee=r(),H=a("figure"),H.innerHTML=Re,te=r(),b=a("p"),b.innerHTML=Ue,ne=r(),C=a("figure"),C.innerHTML=qe,ie=r(),k=a("p"),k.innerHTML=Ne,ae=r(),c=a("h2"),w=a("a"),O=a("span"),Le($.$$.fragment),xe=r(),G=a("span"),G.textContent=je,se=r(),P=a("p"),P.textContent=Ge,re=r(),A=a("ul"),A.innerHTML=ze,oe=r(),E=a("p"),E.innerHTML=We,le=r(),S=a("ul"),S.innerHTML=De,ue=r(),F=a("p"),F.innerHTML=Oe,me=r(),I=a("img"),ge=r(),R=a("ul"),R.innerHTML=Je,pe=r(),U=a("figure"),U.innerHTML=Ke,he=r(),q=a("p"),q.innerHTML=Qe,fe=r(),B=a("p"),this.h()},l(e){const n=lt("svelte-1phssyn",document.head);p=s(n,"META",{name:!0,content:!0}),n.forEach(t),J=o(e),z=s(e,"P",{}),g(z).forEach(t),K=o(e),h=s(e,"H1",{class:!0});var ve=g(h);v=s(ve,"A",{id:!0,class:!0,href:!0});var Ve=g(v);W=s(Ve,"SPAN",{});var Xe=g(W);Me(y.$$.fragment,Xe),Xe.forEach(t),Ve.forEach(t),ye=o(ve),N=s(ve,"SPAN",{"data-svelte-h":!0}),l(N)!=="svelte-4u27mb"&&(N.textContent=Pe),ve.forEach(t),Q=o(e),f=s(e,"H2",{class:!0});var de=g(f);d=s(de,"A",{id:!0,class:!0,href:!0});var Ye=g(d);D=s(Ye,"SPAN",{});var Ze=g(D);Me(_.$$.fragment,Ze),Ze.forEach(t),Ye.forEach(t),_e=o(de),j=s(de,"SPAN",{"data-svelte-h":!0}),l(j)!=="svelte-30ncbp"&&(j.textContent=Ae),de.forEach(t),V=o(e),x=s(e,"P",{"data-svelte-h":!0}),l(x)!=="svelte-g86ko7"&&(x.innerHTML=Ee),X=o(e),L=s(e,"FIGURE",{"data-svelte-h":!0}),l(L)!=="svelte-kd78jp"&&(L.innerHTML=Se),Y=o(e),M=s(e,"P",{"data-svelte-h":!0}),l(M)!=="svelte-1xcyv7q"&&(M.innerHTML=Fe),Z=o(e),T=s(e,"P",{"data-svelte-h":!0}),l(T)!=="svelte-uacshh"&&(T.innerHTML=Ie),ee=o(e),H=s(e,"FIGURE",{"data-svelte-h":!0}),l(H)!=="svelte-18gvihw"&&(H.innerHTML=Re),te=o(e),b=s(e,"P",{"data-svelte-h":!0}),l(b)!=="svelte-ykw5w2"&&(b.innerHTML=Ue),ne=o(e),C=s(e,"FIGURE",{"data-svelte-h":!0}),l(C)!=="svelte-br0ypy"&&(C.innerHTML=qe),ie=o(e),k=s(e,"P",{"data-svelte-h":!0}),l(k)!=="svelte-1gsuuqt"&&(k.innerHTML=Ne),ae=o(e),c=s(e,"H2",{class:!0});var we=g(c);w=s(we,"A",{id:!0,class:!0,href:!0});var et=g(w);O=s(et,"SPAN",{});var tt=g(O);Me($.$$.fragment,tt),tt.forEach(t),et.forEach(t),xe=o(we),G=s(we,"SPAN",{"data-svelte-h":!0}),l(G)!=="svelte-ermdxl"&&(G.textContent=je),we.forEach(t),se=o(e),P=s(e,"P",{"data-svelte-h":!0}),l(P)!=="svelte-13iburr"&&(P.textContent=Ge),re=o(e),A=s(e,"UL",{"data-svelte-h":!0}),l(A)!=="svelte-fp6vdn"&&(A.innerHTML=ze),oe=o(e),E=s(e,"P",{"data-svelte-h":!0}),l(E)!=="svelte-amyg09"&&(E.innerHTML=We),le=o(e),S=s(e,"UL",{"data-svelte-h":!0}),l(S)!=="svelte-i7nze"&&(S.innerHTML=De),ue=o(e),F=s(e,"P",{"data-svelte-h":!0}),l(F)!=="svelte-mn21m8"&&(F.innerHTML=Oe),me=o(e),I=s(e,"IMG",{src:!0,alt:!0}),ge=o(e),R=s(e,"UL",{"data-svelte-h":!0}),l(R)!=="svelte-1qzm0t4"&&(R.innerHTML=Je),pe=o(e),U=s(e,"FIGURE",{"data-svelte-h":!0}),l(U)!=="svelte-1qgya3o"&&(U.innerHTML=Ke),he=o(e),q=s(e,"P",{"data-svelte-h":!0}),l(q)!=="svelte-patx3x"&&(q.innerHTML=Qe),fe=o(e),B=s(e,"P",{}),g(B).forEach(t),this.h()},h(){u(p,"name","hf:doc:metadata"),u(p,"content",JSON.stringify(mt)),u(v,"id","an-introduction-to-multiagents-reinforcement-learning-marl"),u(v,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(v,"href","#an-introduction-to-multiagents-reinforcement-learning-marl"),u(h,"class","relative group"),u(d,"id","from-single-agent-to-multiple-agents"),u(d,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(d,"href","#from-single-agent-to-multiple-agents"),u(f,"class","relative group"),u(w,"id","different-types-of-multiagent-environments"),u(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(w,"href","#different-types-of-multiagent-environments"),u(c,"class","relative group"),it(I.src,Be="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/tennis.png")||u(I,"src",Be),u(I,"alt","Tennis")},m(e,n){m(document.head,p),i(e,J,n),i(e,z,n),i(e,K,n),i(e,h,n),m(h,v),m(v,W),Te(y,W,null),m(h,ye),m(h,N),i(e,Q,n),i(e,f,n),m(f,d),m(d,D),Te(_,D,null),m(f,_e),m(f,j),i(e,V,n),i(e,x,n),i(e,X,n),i(e,L,n),i(e,Y,n),i(e,M,n),i(e,Z,n),i(e,T,n),i(e,ee,n),i(e,H,n),i(e,te,n),i(e,b,n),i(e,ne,n),i(e,C,n),i(e,ie,n),i(e,k,n),i(e,ae,n),i(e,c,n),m(c,w),m(w,O),Te($,O,null),m(c,xe),m(c,G),i(e,se,n),i(e,P,n),i(e,re,n),i(e,A,n),i(e,oe,n),i(e,E,n),i(e,le,n),i(e,S,n),i(e,ue,n),i(e,F,n),i(e,me,n),i(e,I,n),i(e,ge,n),i(e,R,n),i(e,pe,n),i(e,U,n),i(e,he,n),i(e,q,n),i(e,fe,n),i(e,B,n),ce=!0},p:at,i(e){ce||(He(y.$$.fragment,e),He(_.$$.fragment,e),He($.$$.fragment,e),ce=!0)},o(e){be(y.$$.fragment,e),be(_.$$.fragment,e),be($.$$.fragment,e),ce=!1},d(e){e&&(t(J),t(z),t(K),t(h),t(Q),t(f),t(V),t(x),t(X),t(L),t(Y),t(M),t(Z),t(T),t(ee),t(H),t(te),t(b),t(ne),t(C),t(ie),t(k),t(ae),t(c),t(se),t(P),t(re),t(A),t(oe),t(E),t(le),t(S),t(ue),t(F),t(me),t(I),t(ge),t(R),t(pe),t(U),t(he),t(q),t(fe),t(B)),t(p),Ce(y),Ce(_),Ce($)}}}const mt={local:"an-introduction-to-multiagents-reinforcement-learning-marl",sections:[{local:"from-single-agent-to-multiple-agents",title:"From single agent to multiple agents"},{local:"different-types-of-multiagent-environments",title:"Different types of multi-agent environments"}],title:"An introduction to Multi-Agents Reinforcement Learning (MARL)"};function gt($e){return st(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ct extends rt{constructor(p){super(),ot(this,p,gt,ut,nt,{})}}export{ct as component};
