import{s as ht,f as ut,n as dt,o as gt}from"../chunks/scheduler.37c15a92.js";import{S as ft,i as vt,g as s,s as l,u as yt,m as W,H as wt,A as xt,h as i,f as e,c as o,j as M,v as _t,y as p,n as X,B as bt,k as d,o as h,a as n,w as Pt,d as Ct,t as Lt,x as Tt}from"../chunks/index.b01106c0.js";import{I as Mt}from"../chunks/IconCopyLink.77b762b4.js";function Ht(Y){let c,E,H,O,m,u,k,g,V,C,Z="Introduction",$,f,tt,z,v,et="In Unit 6, we learned about Advantage Actor Critic (A2C), a hybrid architecture combining value-based and policy-based methods that helps to stabilize the training by reducing the variance with:",I,y,at="<li><em>An Actor</em> that controls <strong>how our agent behaves</strong> (policy-based method).</li> <li><em>A Critic</em> that measures <strong>how good the action taken is</strong> (value-based method).</li>",S,r,K,L,nt="improves our agent’s training stability by avoiding policy updates that are too large",Q,U,pt='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',N,R,w,st="Doing this will ensure <strong>that our policy update will not be too large and that the training is more stable.</strong>",q,x,it="This Unit is in two parts:",D,_,lt='<li>In this first part, you’ll learn the theory behind PPO and code your PPO agent from scratch using the <a href="https://github.com/vwxyzjn/cleanrl" rel="nofollow">CleanRL</a> implementation. To test its robustness you’ll use LunarLander-v2. LunarLander-v2 <strong>is the first environment you used when you started this course</strong>. At that time, you didn’t know how PPO worked, and now, <strong>you can code it from scratch and train it. How incredible is that 🤩</strong>.</li> <li>In the second part, we’ll get deeper into PPO optimization by using <a href="https://samplefactory.dev/" rel="nofollow">Sample-Factory</a> and train an agent playing vizdoom (an open source version of Doom).</li>',G,b,ot='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/environments.png" alt="Environment"/> <figcaption>These are the environments you&#39;re going to use to train your agents: VizDoom environments</figcaption>',j,P,rt="Sound exciting? Let’s get started! 🚀",F,A,B;return g=new Mt({}),{c(){c=s("meta"),E=l(),H=s("p"),O=l(),m=s("h1"),u=s("a"),k=s("span"),yt(g.$$.fragment),V=l(),C=s("span"),C.textContent=Z,$=l(),f=s("img"),z=l(),v=s("p"),v.textContent=et,I=l(),y=s("ul"),y.innerHTML=at,S=l(),r=s("p"),K=W("Today we’ll learn about Proximal Policy Optimization (PPO), an architecture that "),L=s("strong"),L.textContent=nt,Q=W(". To do that, we use a ratio that indicates the difference between our current and old policy and clip this ratio to a specific range "),U=new wt(!1),N=W(" ."),R=l(),w=s("p"),w.innerHTML=st,q=l(),x=s("p"),x.textContent=it,D=l(),_=s("ul"),_.innerHTML=lt,G=l(),b=s("figure"),b.innerHTML=ot,j=l(),P=s("p"),P.textContent=rt,F=l(),A=s("p"),this.h()},l(t){const a=xt("svelte-1phssyn",document.head);c=i(a,"META",{name:!0,content:!0}),a.forEach(e),E=o(t),H=i(t,"P",{}),M(H).forEach(e),O=o(t),m=i(t,"H1",{class:!0});var J=M(m);u=i(J,"A",{id:!0,class:!0,href:!0});var ct=M(u);k=i(ct,"SPAN",{});var mt=M(k);_t(g.$$.fragment,mt),mt.forEach(e),ct.forEach(e),V=o(J),C=i(J,"SPAN",{"data-svelte-h":!0}),p(C)!=="svelte-agc3q7"&&(C.textContent=Z),J.forEach(e),$=o(t),f=i(t,"IMG",{src:!0,alt:!0}),z=o(t),v=i(t,"P",{"data-svelte-h":!0}),p(v)!=="svelte-1028gae"&&(v.textContent=et),I=o(t),y=i(t,"UL",{"data-svelte-h":!0}),p(y)!=="svelte-1esiva3"&&(y.innerHTML=at),S=o(t),r=i(t,"P",{});var T=M(r);K=X(T,"Today we’ll learn about Proximal Policy Optimization (PPO), an architecture that "),L=i(T,"STRONG",{"data-svelte-h":!0}),p(L)!=="svelte-20y8ah"&&(L.textContent=nt),Q=X(T,". To do that, we use a ratio that indicates the difference between our current and old policy and clip this ratio to a specific range "),U=bt(T,!1),N=X(T," ."),T.forEach(e),R=o(t),w=i(t,"P",{"data-svelte-h":!0}),p(w)!=="svelte-1tdswvm"&&(w.innerHTML=st),q=o(t),x=i(t,"P",{"data-svelte-h":!0}),p(x)!=="svelte-6tzgaz"&&(x.textContent=it),D=o(t),_=i(t,"UL",{"data-svelte-h":!0}),p(_)!=="svelte-ktbxxa"&&(_.innerHTML=lt),G=o(t),b=i(t,"FIGURE",{"data-svelte-h":!0}),p(b)!=="svelte-87htwd"&&(b.innerHTML=ot),j=o(t),P=i(t,"P",{"data-svelte-h":!0}),p(P)!=="svelte-1i7vabt"&&(P.textContent=rt),F=o(t),A=i(t,"P",{}),M(A).forEach(e),this.h()},h(){d(c,"name","hf:doc:metadata"),d(c,"content",JSON.stringify(kt)),d(u,"id","introduction"),d(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(u,"href","#introduction"),d(m,"class","relative group"),ut(f.src,tt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/thumbnail.png")||d(f,"src",tt),d(f,"alt","Unit 8"),U.a=N},m(t,a){h(document.head,c),n(t,E,a),n(t,H,a),n(t,O,a),n(t,m,a),h(m,u),h(u,k),Pt(g,k,null),h(m,V),h(m,C),n(t,$,a),n(t,f,a),n(t,z,a),n(t,v,a),n(t,I,a),n(t,y,a),n(t,S,a),n(t,r,a),h(r,K),h(r,L),h(r,Q),U.m(pt,r),h(r,N),n(t,R,a),n(t,w,a),n(t,q,a),n(t,x,a),n(t,D,a),n(t,_,a),n(t,G,a),n(t,b,a),n(t,j,a),n(t,P,a),n(t,F,a),n(t,A,a),B=!0},p:dt,i(t){B||(Ct(g.$$.fragment,t),B=!0)},o(t){Lt(g.$$.fragment,t),B=!1},d(t){t&&(e(E),e(H),e(O),e(m),e($),e(f),e(z),e(v),e(I),e(y),e(S),e(r),e(R),e(w),e(q),e(x),e(D),e(_),e(G),e(b),e(j),e(P),e(F),e(A)),e(c),Tt(g)}}}const kt={local:"introduction",title:"Introduction "};function At(Y){return gt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class zt extends ft{constructor(c){super(),vt(this,c,At,Ht,ht,{})}}export{zt as component};
