import{s as et,n as at,o as nt}from"../chunks/scheduler.37c15a92.js";import{S as st,i as it,g as s,s as p,u as ot,m as Y,H as lt,A as rt,h as i,f as e,c as m,j as C,v as pt,y,n as Z,B as mt,k as w,o as c,a as n,w as ct,d as ht,t as ut,x as gt}from"../chunks/index.b01106c0.js";import{I as ft}from"../chunks/IconCopyLink.77b762b4.js";function dt(I){let l,H,k,L,r,h,T,g,z,x,F="The intuition behind PPO",E,f,J="The idea with Proximal Policy Optimization (PPO) is that we want to improve the training stability of the policy by limiting the change you make to the policy at each training epoch: <strong>we want to avoid having too large of a policy update.</strong>",O,d,B="For two reasons:",$,v,W="<li>We know empirically that smaller policy updates during training are <strong>more likely to converge to an optimal solution.</strong></li> <li>A too-big step in a policy update can result in falling “off the cliff” (getting a bad policy) <strong>and taking a long time or even having no possibility to recover.</strong></li>",S,u,D='<img class="center" src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/cliff.jpg" alt="Policy Update cliff"/> <figcaption>Taking smaller policy updates to improve the training stability</figcaption> <figcaption>Modified version from RL — Proximal Policy Optimization (PPO) <a href="https://jonathan-hui.medium.com/rl-proximal-policy-optimization-ppo-explained-77f014ec3f12">Explained by Jonathan Hui</a></figcaption>',A,o,_,K="So with PPO, we update the policy conservatively",G,N,tt='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',R,P,Q="remove the incentive for the current policy to go too far from the old one (hence the proximal policy term).",U,M,j;return g=new ft({}),{c(){l=s("meta"),H=p(),k=s("p"),L=p(),r=s("h1"),h=s("a"),T=s("span"),ot(g.$$.fragment),z=p(),x=s("span"),x.textContent=F,E=p(),f=s("p"),f.innerHTML=J,O=p(),d=s("p"),d.textContent=B,$=p(),v=s("ul"),v.innerHTML=W,S=p(),u=s("figure"),u.innerHTML=D,A=p(),o=s("p"),_=s("strong"),_.textContent=K,G=Y(". To do so, we need to measure how much the current policy changed compared to the former one using a ratio calculation between the current and former policy. And we clip this ratio in a range "),N=new lt(!1),R=Y(", meaning that we "),P=s("strong"),P.textContent=Q,U=p(),M=s("p"),this.h()},l(t){const a=rt("svelte-1phssyn",document.head);l=i(a,"META",{name:!0,content:!0}),a.forEach(e),H=m(t),k=i(t,"P",{}),C(k).forEach(e),L=m(t),r=i(t,"H1",{class:!0});var q=C(r);h=i(q,"A",{id:!0,class:!0,href:!0});var V=C(h);T=i(V,"SPAN",{});var X=C(T);pt(g.$$.fragment,X),X.forEach(e),V.forEach(e),z=m(q),x=i(q,"SPAN",{"data-svelte-h":!0}),y(x)!=="svelte-1qb1l16"&&(x.textContent=F),q.forEach(e),E=m(t),f=i(t,"P",{"data-svelte-h":!0}),y(f)!=="svelte-1v0k3v2"&&(f.innerHTML=J),O=m(t),d=i(t,"P",{"data-svelte-h":!0}),y(d)!=="svelte-158km42"&&(d.textContent=B),$=m(t),v=i(t,"UL",{"data-svelte-h":!0}),y(v)!=="svelte-24i75q"&&(v.innerHTML=W),S=m(t),u=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),y(u)!=="svelte-1uo863i"&&(u.innerHTML=D),A=m(t),o=i(t,"P",{});var b=C(o);_=i(b,"STRONG",{"data-svelte-h":!0}),y(_)!=="svelte-10ggtbr"&&(_.textContent=K),G=Z(b,". To do so, we need to measure how much the current policy changed compared to the former one using a ratio calculation between the current and former policy. And we clip this ratio in a range "),N=mt(b,!1),R=Z(b,", meaning that we "),P=i(b,"STRONG",{"data-svelte-h":!0}),y(P)!=="svelte-hv01ak"&&(P.textContent=Q),b.forEach(e),U=m(t),M=i(t,"P",{}),C(M).forEach(e),this.h()},h(){w(l,"name","hf:doc:metadata"),w(l,"content",JSON.stringify(vt)),w(h,"id","the-intuition-behind-ppo"),w(h,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),w(h,"href","#the-intuition-behind-ppo"),w(r,"class","relative group"),w(u,"class","image table text-center m-0 w-full"),N.a=R},m(t,a){c(document.head,l),n(t,H,a),n(t,k,a),n(t,L,a),n(t,r,a),c(r,h),c(h,T),ct(g,T,null),c(r,z),c(r,x),n(t,E,a),n(t,f,a),n(t,O,a),n(t,d,a),n(t,$,a),n(t,v,a),n(t,S,a),n(t,u,a),n(t,A,a),n(t,o,a),c(o,_),c(o,G),N.m(tt,o),c(o,R),c(o,P),n(t,U,a),n(t,M,a),j=!0},p:at,i(t){j||(ht(g.$$.fragment,t),j=!0)},o(t){ut(g.$$.fragment,t),j=!1},d(t){t&&(e(H),e(k),e(L),e(r),e(E),e(f),e(O),e(d),e($),e(v),e(S),e(u),e(A),e(o),e(U),e(M)),e(l),gt(g)}}}const vt={local:"the-intuition-behind-ppo",title:"The intuition behind PPO "};function yt(I){return nt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Pt extends st{constructor(l){super(),it(this,l,yt,dt,et,{})}}export{Pt as component};
