import{s as Ha,f as Ea,n as za,o as Aa}from"../chunks/scheduler.37c15a92.js";import{S as Sa,i as Ia,g as n,s as p,u as we,m as c,H as C,A as ja,h as i,f as e,c as r,j as h,v as be,y as o,n as g,B as M,k as m,o as l,a as s,w as ye,d as xe,t as _e,x as ke}from"../chunks/index.b01106c0.js";import{I as Ce}from"../chunks/IconCopyLink.77b762b4.js";function Oa(Be){let f,bt,ht,yt,d,P,ct,j,Me,et,De="Visualize the Clipped Surrogate Objective Function",xt,O,Ne="Don’t worry. <strong>It’s normal if this seems complex to handle right now</strong>. But we’re going to see what this Clipped Surrogate Objective Function looks like, and this will help you to visualize better what’s going on.",_t,T,Re=`<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/recap.jpg" alt="PPO"/> <figcaption><a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf">Table from &quot;Towards Delivering a Coherent Self-Contained
    Explanation of Proximal Policy Optimization&quot; by Daniel Bick</a></figcaption>`,kt,q,Ge="We have six different situations. Remember first that we take the minimum between the clipped and unclipped objectives.",Ct,w,L,gt,B,Pe,at,Fe="Case 1 and 2: the ratio is between the range",Mt,b,Te,st,Ue="the clipping does not apply since the ratio is between the range",Le,Pt,xa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',Tt,D,We="In situation 1, we have a positive advantage: the <strong>action is better than the average</strong> of all the actions in that state. Therefore, we should encourage our current policy to increase the probability of taking that action in that state.",Lt,N,Ve="Since the ratio is between intervals, <strong>we can increase our policy’s probability of taking that action at that state.</strong>",$t,R,Ye="In situation 2, we have a negative advantage: the action is worse than the average of all actions at that state. Therefore, we should discourage our current policy from taking that action in that state.",Ht,G,Je="Since the ratio is between intervals, <strong>we can decrease the probability that our policy takes that action at that state.</strong>",Et,y,$,ut,F,$e,nt,Ke="Case 3 and 4: the ratio is below the range",zt,H,Qe=`<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/recap.jpg" alt="PPO"/> <figcaption><a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf">Table from &quot;Towards Delivering a Coherent Self-Contained
    Explanation of Proximal Policy Optimization&quot; by Daniel Bick</a></figcaption>`,At,E,He,St,_a='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon] </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',It,jt,U,Xe="If, like in situation 3, the advantage estimate is positive (A&gt;0), then <strong>you want to increase the probability of taking that action at that state.</strong>",Ot,W,Ze="But if, like situation 4, the advantage estimate is negative, <strong>we don’t want to decrease further</strong> the probability of taking that action at that state. Therefore, the gradient is = 0 (since we’re on a flat line), so we don’t update our weights.",qt,x,z,vt,V,Ee,it,ta="Case 5 and 6: the ratio is above the range",Bt,A,ea=`<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/recap.jpg" alt="PPO"/> <figcaption><a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf">Table from &quot;Towards Delivering a Coherent Self-Contained
    Explanation of Proximal Policy Optimization&quot; by Daniel Bick</a></figcaption>`,Dt,_,ze,Nt,ka='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',Rt,lt,aa="much higher than in the former policy.",Gt,Y,sa="If, like in situation 5, the advantage is positive, <strong>we don’t want to get too greedy</strong>. We already have a higher probability of taking that action at that state than the former policy. Therefore, the gradient is = 0 (since we’re on a flat line), so we don’t update our weights.",Ft,J,na="If, like in situation 6, the advantage is negative, we want to decrease the probability of taking that action at that state.",Ut,K,ia="So if we recap, <strong>we only update the policy with the unclipped objective part</strong>. When the minimum is the clipped objective part, we don’t update our policy weights since the gradient will equal 0.",Wt,Q,la="So we update our policy  only if:",Vt,S,pt,Ae,Yt,Ca='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',Se,rt,pa="Our ratio is outside the range, but <strong>the advantage leads to getting closer to the range</strong><ul><li>Being below the ratio but the advantage is &gt; 0</li> <li>Being above the ratio but the advantage is &lt; 0</li></ul>",Jt,u,ot,ra="You might wonder why, when the minimum is the clipped ratio, the gradient is 0.",Ie,Kt,Ma='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo><mo>∗</mo><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> r_t(\\theta) * A_t </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Qt,Xt,Pa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">(</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo stretchy="false">)</mo><mo>∗</mo><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> (1 - \\epsilon)* A_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">(</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Zt,te,Ta='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">(</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">)</mo><mo>∗</mo><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> (1 + \\epsilon)* A_t</annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">(</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',ee,ae,v,je,mt,oa="we restrict the range that the current policy can vary from the old one.",Oe,se,La='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mn>1</mn><mo>+</mo><mi>ϵ</mi></mrow><annotation encoding="application/x-tex"> 1 + \\epsilon </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">ϵ</span></span></span></span>',ne,ie,$a='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mn>1</mn><mo>−</mo><mi>ϵ</mi></mrow><annotation encoding="application/x-tex"> 1 - \\epsilon </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">ϵ</span></span></span></span>',le,pe,X,ma="The final Clipped Surrogate Objective Loss for PPO Actor-Critic style looks like this, it’s a combination of Clipped Surrogate Objective function, Value Loss Function and Entropy bonus:",re,Z,ha,oe,tt,ca='That was quite complex. Take time to understand these situations by looking at the table and the graph. <strong>You must understand why this makes sense.</strong> If you want to go deeper, the best resource is the article <a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf" rel="nofollow">Towards Delivering a Coherent Self-Contained Explanation of Proximal Policy Optimization” by Daniel Bick, especially part 3.4</a>.',me,ft,he;return j=new Ce({}),B=new Ce({}),F=new Ce({}),V=new Ce({}),{c(){f=n("meta"),bt=p(),ht=n("p"),yt=p(),d=n("h1"),P=n("a"),ct=n("span"),we(j.$$.fragment),Me=p(),et=n("span"),et.textContent=De,xt=p(),O=n("p"),O.innerHTML=Ne,_t=p(),T=n("figure"),T.innerHTML=Re,kt=p(),q=n("p"),q.textContent=Ge,Ct=p(),w=n("h2"),L=n("a"),gt=n("span"),we(B.$$.fragment),Pe=p(),at=n("span"),at.textContent=Fe,Mt=p(),b=n("p"),Te=c("In situations 1 and 2, "),st=n("strong"),st.textContent=Ue,Le=p(),Pt=new C(!1),Tt=p(),D=n("p"),D.innerHTML=We,Lt=p(),N=n("p"),N.innerHTML=Ve,$t=p(),R=n("p"),R.textContent=Ye,Ht=p(),G=n("p"),G.innerHTML=Je,Et=p(),y=n("h2"),$=n("a"),ut=n("span"),we(F.$$.fragment),$e=p(),nt=n("span"),nt.textContent=Ke,zt=p(),H=n("figure"),H.innerHTML=Qe,At=p(),E=n("p"),He=c("If the probability ratio is lower than "),St=new C(!1),It=c(", the probability of taking that action at that state is much lower than with the old policy."),jt=p(),U=n("p"),U.innerHTML=Xe,Ot=p(),W=n("p"),W.innerHTML=Ze,qt=p(),x=n("h2"),z=n("a"),vt=n("span"),we(V.$$.fragment),Ee=p(),it=n("span"),it.textContent=ta,Bt=p(),A=n("figure"),A.innerHTML=ea,Dt=p(),_=n("p"),ze=c("If the probability ratio is higher than "),Nt=new C(!1),Rt=c(", the probability of taking that action at that state in the current policy is "),lt=n("strong"),lt.textContent=aa,Gt=p(),Y=n("p"),Y.innerHTML=sa,Ft=p(),J=n("p"),J.textContent=na,Ut=p(),K=n("p"),K.innerHTML=ia,Wt=p(),Q=n("p"),Q.textContent=la,Vt=p(),S=n("ul"),pt=n("li"),Ae=c("Our ratio is in the range "),Yt=new C(!1),Se=p(),rt=n("li"),rt.innerHTML=pa,Jt=p(),u=n("p"),ot=n("strong"),ot.textContent=ra,Ie=c(" When the ratio is clipped, the derivative in this case will not be the derivative of the "),Kt=new C(!1),Qt=c("   but the derivative of either "),Xt=new C(!1),Zt=c(" or the derivative of "),te=new C(!1),ee=c(" which both = 0."),ae=p(),v=n("p"),je=c("To summarize, thanks to this clipped surrogate objective, "),mt=n("strong"),mt.textContent=oa,Oe=c(" Because we remove the incentive for the probability ratio to move outside of the interval since the clip forces the gradient to be zero. If the ratio is > "),se=new C(!1),ne=c(" or < "),ie=new C(!1),le=c(" the gradient will be equal to 0."),pe=p(),X=n("p"),X.textContent=ma,re=p(),Z=n("img"),oe=p(),tt=n("p"),tt.innerHTML=ca,me=p(),ft=n("p"),this.h()},l(t){const a=ja("svelte-1phssyn",document.head);f=i(a,"META",{name:!0,content:!0}),a.forEach(e),bt=r(t),ht=i(t,"P",{}),h(ht).forEach(e),yt=r(t),d=i(t,"H1",{class:!0});var ce=h(d);P=i(ce,"A",{id:!0,class:!0,href:!0});var ga=h(P);ct=i(ga,"SPAN",{});var ua=h(ct);be(j.$$.fragment,ua),ua.forEach(e),ga.forEach(e),Me=r(ce),et=i(ce,"SPAN",{"data-svelte-h":!0}),o(et)!=="svelte-87vnga"&&(et.textContent=De),ce.forEach(e),xt=r(t),O=i(t,"P",{"data-svelte-h":!0}),o(O)!=="svelte-8fcaqu"&&(O.innerHTML=Ne),_t=r(t),T=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),o(T)!=="svelte-1kvrq9v"&&(T.innerHTML=Re),kt=r(t),q=i(t,"P",{"data-svelte-h":!0}),o(q)!=="svelte-kt354t"&&(q.textContent=Ge),Ct=r(t),w=i(t,"H2",{class:!0});var ge=h(w);L=i(ge,"A",{id:!0,class:!0,href:!0});var va=h(L);gt=i(va,"SPAN",{});var fa=h(gt);be(B.$$.fragment,fa),fa.forEach(e),va.forEach(e),Pe=r(ge),at=i(ge,"SPAN",{"data-svelte-h":!0}),o(at)!=="svelte-122yzkl"&&(at.textContent=Fe),ge.forEach(e),Mt=r(t),b=i(t,"P",{});var dt=h(b);Te=g(dt,"In situations 1 and 2, "),st=i(dt,"STRONG",{"data-svelte-h":!0}),o(st)!=="svelte-w52w77"&&(st.textContent=Ue),Le=r(dt),Pt=M(dt,!1),dt.forEach(e),Tt=r(t),D=i(t,"P",{"data-svelte-h":!0}),o(D)!=="svelte-1cqqr4g"&&(D.innerHTML=We),Lt=r(t),N=i(t,"P",{"data-svelte-h":!0}),o(N)!=="svelte-jfeco7"&&(N.innerHTML=Ve),$t=r(t),R=i(t,"P",{"data-svelte-h":!0}),o(R)!=="svelte-uloelw"&&(R.textContent=Ye),Ht=r(t),G=i(t,"P",{"data-svelte-h":!0}),o(G)!=="svelte-1ffs0w0"&&(G.innerHTML=Je),Et=r(t),y=i(t,"H2",{class:!0});var ue=h(y);$=i(ue,"A",{id:!0,class:!0,href:!0});var da=h($);ut=i(da,"SPAN",{});var wa=h(ut);be(F.$$.fragment,wa),wa.forEach(e),da.forEach(e),$e=r(ue),nt=i(ue,"SPAN",{"data-svelte-h":!0}),o(nt)!=="svelte-11x4b8q"&&(nt.textContent=Ke),ue.forEach(e),zt=r(t),H=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),o(H)!=="svelte-kxqh68"&&(H.innerHTML=Qe),At=r(t),E=i(t,"P",{});var ve=h(E);He=g(ve,"If the probability ratio is lower than "),St=M(ve,!1),It=g(ve,", the probability of taking that action at that state is much lower than with the old policy."),ve.forEach(e),jt=r(t),U=i(t,"P",{"data-svelte-h":!0}),o(U)!=="svelte-1x6bxjm"&&(U.innerHTML=Xe),Ot=r(t),W=i(t,"P",{"data-svelte-h":!0}),o(W)!=="svelte-1l49ylb"&&(W.innerHTML=Ze),qt=r(t),x=i(t,"H2",{class:!0});var fe=h(x);z=i(fe,"A",{id:!0,class:!0,href:!0});var ba=h(z);vt=i(ba,"SPAN",{});var ya=h(vt);be(V.$$.fragment,ya),ya.forEach(e),ba.forEach(e),Ee=r(fe),it=i(fe,"SPAN",{"data-svelte-h":!0}),o(it)!=="svelte-grzz6q"&&(it.textContent=ta),fe.forEach(e),Bt=r(t),A=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),o(A)!=="svelte-kxqh68"&&(A.innerHTML=ea),Dt=r(t),_=i(t,"P",{});var wt=h(_);ze=g(wt,"If the probability ratio is higher than "),Nt=M(wt,!1),Rt=g(wt,", the probability of taking that action at that state in the current policy is "),lt=i(wt,"STRONG",{"data-svelte-h":!0}),o(lt)!=="svelte-qu8nx6"&&(lt.textContent=aa),wt.forEach(e),Gt=r(t),Y=i(t,"P",{"data-svelte-h":!0}),o(Y)!=="svelte-1ptdkag"&&(Y.innerHTML=sa),Ft=r(t),J=i(t,"P",{"data-svelte-h":!0}),o(J)!=="svelte-yugfug"&&(J.textContent=na),Ut=r(t),K=i(t,"P",{"data-svelte-h":!0}),o(K)!=="svelte-1eb9ayw"&&(K.innerHTML=ia),Wt=r(t),Q=i(t,"P",{"data-svelte-h":!0}),o(Q)!=="svelte-pg5tgk"&&(Q.textContent=la),Vt=r(t),S=i(t,"UL",{});var de=h(S);pt=i(de,"LI",{});var qe=h(pt);Ae=g(qe,"Our ratio is in the range "),Yt=M(qe,!1),qe.forEach(e),Se=r(de),rt=i(de,"LI",{"data-svelte-h":!0}),o(rt)!=="svelte-1hd4gm6"&&(rt.innerHTML=pa),de.forEach(e),Jt=r(t),u=i(t,"P",{});var k=h(u);ot=i(k,"STRONG",{"data-svelte-h":!0}),o(ot)!=="svelte-xl5clc"&&(ot.textContent=ra),Ie=g(k," When the ratio is clipped, the derivative in this case will not be the derivative of the "),Kt=M(k,!1),Qt=g(k,"   but the derivative of either "),Xt=M(k,!1),Zt=g(k," or the derivative of "),te=M(k,!1),ee=g(k," which both = 0."),k.forEach(e),ae=r(t),v=i(t,"P",{});var I=h(v);je=g(I,"To summarize, thanks to this clipped surrogate objective, "),mt=i(I,"STRONG",{"data-svelte-h":!0}),o(mt)!=="svelte-vpub9x"&&(mt.textContent=oa),Oe=g(I," Because we remove the incentive for the probability ratio to move outside of the interval since the clip forces the gradient to be zero. If the ratio is > "),se=M(I,!1),ne=g(I," or < "),ie=M(I,!1),le=g(I," the gradient will be equal to 0."),I.forEach(e),pe=r(t),X=i(t,"P",{"data-svelte-h":!0}),o(X)!=="svelte-d7ieux"&&(X.textContent=ma),re=r(t),Z=i(t,"IMG",{src:!0,alt:!0}),oe=r(t),tt=i(t,"P",{"data-svelte-h":!0}),o(tt)!=="svelte-256dgf"&&(tt.innerHTML=ca),me=r(t),ft=i(t,"P",{}),h(ft).forEach(e),this.h()},h(){m(f,"name","hf:doc:metadata"),m(f,"content",JSON.stringify(qa)),m(P,"id","visualize-the-clipped-surrogate-objective-function"),m(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(P,"href","#visualize-the-clipped-surrogate-objective-function"),m(d,"class","relative group"),m(T,"class","image table text-center m-0 w-full"),m(L,"id","case-1-and-2-the-ratio-is-between-the-range"),m(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(L,"href","#case-1-and-2-the-ratio-is-between-the-range"),m(w,"class","relative group"),Pt.a=null,m($,"id","case-3-and-4-the-ratio-is-below-the-range"),m($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m($,"href","#case-3-and-4-the-ratio-is-below-the-range"),m(y,"class","relative group"),m(H,"class","image table text-center m-0 w-full"),St.a=It,m(z,"id","case-5-and-6-the-ratio-is-above-the-range"),m(z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(z,"href","#case-5-and-6-the-ratio-is-above-the-range"),m(x,"class","relative group"),m(A,"class","image table text-center m-0 w-full"),Nt.a=Rt,Yt.a=null,Kt.a=Qt,Xt.a=Zt,te.a=ee,se.a=ne,ie.a=le,Ea(Z.src,ha="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/ppo-objective.jpg")||m(Z,"src",ha),m(Z,"alt","PPO objective")},m(t,a){l(document.head,f),s(t,bt,a),s(t,ht,a),s(t,yt,a),s(t,d,a),l(d,P),l(P,ct),ye(j,ct,null),l(d,Me),l(d,et),s(t,xt,a),s(t,O,a),s(t,_t,a),s(t,T,a),s(t,kt,a),s(t,q,a),s(t,Ct,a),s(t,w,a),l(w,L),l(L,gt),ye(B,gt,null),l(w,Pe),l(w,at),s(t,Mt,a),s(t,b,a),l(b,Te),l(b,st),l(b,Le),Pt.m(xa,b),s(t,Tt,a),s(t,D,a),s(t,Lt,a),s(t,N,a),s(t,$t,a),s(t,R,a),s(t,Ht,a),s(t,G,a),s(t,Et,a),s(t,y,a),l(y,$),l($,ut),ye(F,ut,null),l(y,$e),l(y,nt),s(t,zt,a),s(t,H,a),s(t,At,a),s(t,E,a),l(E,He),St.m(_a,E),l(E,It),s(t,jt,a),s(t,U,a),s(t,Ot,a),s(t,W,a),s(t,qt,a),s(t,x,a),l(x,z),l(z,vt),ye(V,vt,null),l(x,Ee),l(x,it),s(t,Bt,a),s(t,A,a),s(t,Dt,a),s(t,_,a),l(_,ze),Nt.m(ka,_),l(_,Rt),l(_,lt),s(t,Gt,a),s(t,Y,a),s(t,Ft,a),s(t,J,a),s(t,Ut,a),s(t,K,a),s(t,Wt,a),s(t,Q,a),s(t,Vt,a),s(t,S,a),l(S,pt),l(pt,Ae),Yt.m(Ca,pt),l(S,Se),l(S,rt),s(t,Jt,a),s(t,u,a),l(u,ot),l(u,Ie),Kt.m(Ma,u),l(u,Qt),Xt.m(Pa,u),l(u,Zt),te.m(Ta,u),l(u,ee),s(t,ae,a),s(t,v,a),l(v,je),l(v,mt),l(v,Oe),se.m(La,v),l(v,ne),ie.m($a,v),l(v,le),s(t,pe,a),s(t,X,a),s(t,re,a),s(t,Z,a),s(t,oe,a),s(t,tt,a),s(t,me,a),s(t,ft,a),he=!0},p:za,i(t){he||(xe(j.$$.fragment,t),xe(B.$$.fragment,t),xe(F.$$.fragment,t),xe(V.$$.fragment,t),he=!0)},o(t){_e(j.$$.fragment,t),_e(B.$$.fragment,t),_e(F.$$.fragment,t),_e(V.$$.fragment,t),he=!1},d(t){t&&(e(bt),e(ht),e(yt),e(d),e(xt),e(O),e(_t),e(T),e(kt),e(q),e(Ct),e(w),e(Mt),e(b),e(Tt),e(D),e(Lt),e(N),e($t),e(R),e(Ht),e(G),e(Et),e(y),e(zt),e(H),e(At),e(E),e(jt),e(U),e(Ot),e(W),e(qt),e(x),e(Bt),e(A),e(Dt),e(_),e(Gt),e(Y),e(Ft),e(J),e(Ut),e(K),e(Wt),e(Q),e(Vt),e(S),e(Jt),e(u),e(ae),e(v),e(pe),e(X),e(re),e(Z),e(oe),e(tt),e(me),e(ft)),e(f),ke(j),ke(B),ke(F),ke(V)}}}const qa={local:"visualize-the-clipped-surrogate-objective-function",sections:[{local:"case-1-and-2-the-ratio-is-between-the-range",title:"Case 1 and 2: the ratio is between the range"},{local:"case-3-and-4-the-ratio-is-below-the-range",title:"Case 3 and 4: the ratio is below the range"},{local:"case-5-and-6-the-ratio-is-above-the-range",title:"Case 5 and 6: the ratio is above the range"}],title:"Visualize the Clipped Surrogate Objective Function"};function Ba(Be){return Aa(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ga extends Sa{constructor(f){super(),Ia(this,f,Ba,Oa,Ha,{})}}export{Ga as component};
